<?php
class Bootstrap extends Zend_Application_Bootstrap_Bootstrap
{

    /**
     * Initialize the constant value that will be useful in the entire systems
     */
    protected function _initRegisterConstant()
    {
        Zend_Session::start();
        
        // Helper path
        Zend_Controller_Action_HelperBroker::addPath(APPLICATION_PATH .'/controllers/helpers');
        
    	// Get the value of application.ini
  		$configArray 	= $this->getOptions();
  		$this->config 	= new Zend_Config($configArray);
		$config 		= $this->config;
		
		// Register the db config
		$dbConfig = $config->resources->db;
		Zend_Registry::set('dbConfig', $dbConfig);
		
		// Register the table prefix
		$tablePrefix 	= $config->resources->db->params->prefix;
		Zend_Registry::set('tablePrefix', $tablePrefix);

	}


    /**
     * Initialize the layout loader
     */
    protected function _initLayoutHelper()
    {
        $this->bootstrap('frontController');
        $layout = Zend_Controller_Action_HelperBroker::addHelper(
            new Amz_Controller_Action_Helper_LayoutLoader()
        );
    }


    /**
     * Initialize zf debug.
     */
//    protected function _initZFDebug()
//    {
//        $autoloader = Zend_Loader_Autoloader::getInstance();
//        $autoloader->registerNamespace('ZFDebug');
//        
//        $options = array(
//            'plugins' => array('Variables', 
//               'File' => array('base_path' => '/path/to/project'),
//               'Memory', 
//               'Time', 
//               'Exception')
//        );
//        
//        // Instantiate the database adapter and setup the plugin.
//        // Alternatively just add the plugin like above and rely on the autodiscovery feature.
//        if ($this->hasPluginResource('db')) {
//            $this->bootstrap('db');
//            $db = $this->getPluginResource('db')->getDbAdapter();
//            $options['plugins']['Database']['adapter'] = $db;
//        }
//    
//        // Setup the cache plugin
//        if ($this->hasPluginResource('cache')) {
//            $this->bootstrap('cache');
//            $cache = $this-getPluginResource('cache')->getDbAdapter();
//            $options['plugins']['Cache']['backend'] = $cache->getBackend();
//        }
//    
//        $debug = new ZFDebug_Controller_Plugin_Debug($options);
//        
//        $this->bootstrap('frontController');
//        $frontController = $this->getResource('frontController');
//        $frontController->registerPlugin($debug);
//
//    }
    
    
    /**
     * Get settings from database
     */
   	protected function _initSettings()
	{
		$db      = Zend_Db::factory(Zend_Registry::get('dbConfig'));
		$prefix  = Zend_Registry::get('tablePrefix');
		$query   = new Zend_Db_Select($db);
        
		$query = $db->select();
		$query->from($prefix .  'settings');
		$settings = $db->fetchAll($query);
		
		foreach ($settings as $setting) {
			$datas[$setting['alias']] = $setting['value'];
		}
        Zend_Registry::set('settings', $datas);
	}
    
    
    
    
}