<?php

class ConnectionsController extends Zend_Controller_Action
{
	
    
	/**
	 * Initialize action controller here.
	 */
    public function init()
    {
        // Set the flash messenger
		$this->view->flashMessenger = $this->_helper->flashMessenger->getMessages();

    }



    public function indexAction()
    {
        //user id of user
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        $this->view->userId = $userId;
        
        //fetch status of the user and put it on a session
        $users = new Application_Model_Tables_Users();
        $status = $users->fetchRow($users->select()->where('user_id = ' . $userId, 1));
        if($status->status != 'active')
        {
            //$this->sessionUser->status = 'inactive';
            $this->view->status = 'inactive';
            $this->_redirect('employer');
        }
        else
        {
            //$this->sessionUser->status = 'active';
            $this->view->status = 'active';
        }

        $adapter = Zend_Db_Table_Abstract::getDefaultAdapter();
        $select = new Zend_Db_Select($adapter);
        $select->from('staff_connection')
               ->joinInner('staff_companies', 'staff_connection.connected_id = staff_companies.user_id')
               ->where("staff_connection.account_id = $userId")
               ->where("staff_connection.status = 'not-deleted'");
        $rows = $adapter->fetchAll($select);
        $this->view->count = count($rows);

        $page       = $this->_getParam('p', 1);
        $paginator  = Zend_Paginator::factory($rows);
        $paginator->setItemCountPerPage(20);
        $paginator->setCurrentPageNumber($page);
        $this->view->rows = $paginator;
    }



    public function addConnectionAction()
    {
    	$userId = Zend_Auth::getInstance()->getIdentity()->user_id;
       
    	if($this->getRequest()->getPost('add_connection'))
    	{
    		$connectedId = $this->_request->getPost('connected_id');

    		if(!empty($connectedId))
    		{   
                $connection = new Application_Model_Tables_Connection();
                $row = $connection->fetchAll($connection->select()->where('account_id = ?', $userId)->where('connected_id = ?', $connectedId)->where("status = 'deleted'"));
                if(count($row) == 1)
                {
                    $connection->restoreConnection($userId, $connectedId);
                    $this->_redirect("index/search-view/category/companies/id/$connectedId");
                }
                elseif(count($row) > 0)
                {
                    $connection->deleteConnection($userId, $connectedId);
                    $connection->addConnection($userId, $connectedId);
                    $this->_redirect("index/search-view/category/companies/id/$connectedId");
                }
                else
                {
        			$connection->addConnection($userId, $connectedId);
        			$this->_redirect("index/search-view/category/companies/id/$connectedId");                
                }
    		}
    	}

        if($this->getRequest()->getPost('remove_connection'))
        {
            $connectedId = $this->_request->getPost('connected_id');
           
            if(!empty($connectedId))
            {
                $connection = new Application_Model_Tables_Connection(); 

                $connection->removeConnection($userId, $connectedId);
                $this->_redirect("index/search-view/category/companies/id/$connectedId");
            }
        }
    }


    public function sendMessageAction()
    {
        $this->request = $this->getRequest();
        $connectedId = $this->request->getParam('id');
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;

        $adapter = Zend_Db_Table_Abstract::getDefaultAdapter();
        $select = new Zend_Db_Select($adapter);
        $select->from('staff_connection')
               ->joinInner('staff_companies', 'staff_connection.connected_id = staff_companies.user_id', array('company_name'))
               ->where("staff_connection.connected_id = $connectedId")
               ->where("staff_connection.account_id = $userId");
        $row = $adapter->fetchRow($select);
        $this->view->row = $row;

        if($this->getRequest()->isPost())
        {
            $receiverId = $this->_request->getPost('receiver_id');
            $subject = $this->_request->getPost('subject');
            $message = $this->_request->getPost('message');

            $this->formDatas = $this->getRequest()->getPost();

            if(empty($receiverId) || empty($subject) || empty($message))
            {
                $this->view->formDatas = $this->formDatas;
            }
            else
            {    
                $inbox = new Application_Model_Tables_Inbox();
                $inbox->addInbox($this->formDatas);
                $sent = new Application_Model_Tables_Sent();
                $sent->addSent($this->formDatas);
                $this->_redirect('connections');
            }
        }
    }


    public function removeConnectionAction()
    {
        $this->request = $this->getRequest();
        $connectedId = $this->request->getParam('id');
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;

        $connection = new Application_Model_Tables_Connection();
        $connection->removeConnection($userId, $connectedId);

        $this->_redirect('connections');
    }


    public function viewConnectionAction()
    {
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        $connectedId = $this->_request->getParam('id');
        if(empty($connectedId))
        {
            $this->_redirect('connections');
        }
        if(empty($userId))
        {
            $this->_redirect('/');
        }

        $connection = new Application_Model_Tables_Connection();
        $result = $connection->fetchRow($connection->select()->where("connected_id = ?", $connectedId)->where("account_id = ?", $userId));
        if(count($result) > 0)
        {
            $companies = new Application_Model_Tables_Companies();
            $row = $companies->fetchRow($companies->select()->where("user_id = ?", $connectedId));
            $this->view->row = $row;
        }
        else
        {
            $this->_redirect('connections');
        }

        $employees = new Application_Model_Tables_Employers();
        $results = $employees->fetchAll($employees->select()->where("user_id = ?", $connectedId));
        $this->view->employeesCount = count($results);
    }

}
?>