<?php

class EmployeesController extends Zend_Controller_Action
{
	
    
	/**
	 * Initialize action controller here.
	 */
    public function init()
    {
        // Set the flash messenger
		$this->view->flashMessenger = $this->_helper->flashMessenger->getMessages();

		$this->sessionUser = new Zend_Session_Namespace("sessionUser");

        $this->sessionListed = new Zend_Session_Namespace("sessionListed");

    }


    public function whitelistedAction()
    {
        if($this->sessionUser->status != 'active')
        {
            $this->_redirect('employer');
        }
        $this->view->status = $this->sessionUser->status;
        
    	$userId = Zend_Auth::getInstance()->getIdentity()->user_id;

    	$adapter = Zend_Db_Table_Abstract::getDefaultAdapter();
    	$select = new Zend_Db_Select($adapter);
    	$select->from('staff_employees_mark', array('mark_created' => 'created'))
    		   ->joinInner('staff_employees', 'staff_employees_mark.employee_id = staff_employees.employee_id')
    		   ->where("staff_employees_mark.user_id = $userId")
               ->where("staff_employees_mark.status != 'deleted'")
    		   ->where("staff_employees_mark.mark_type = 'whitelisted'")
    		   ->where("staff_employees.status != 'deleted'");
    	$results = $adapter->fetchAll($select);
    	$this->view->count = count($results);

        $page       = $this->_getParam('p', 1);
        $paginator  = Zend_Paginator::factory($results);
        $paginator->setItemCountPerPage(20);
        $paginator->setCurrentPageNumber($page);
        $this->view->rows = $paginator;

        //session 
        $this->sessionListed->location = 'whitelisted';
    }


    public function blacklistedAction()
    {
        if($this->sessionUser->status != 'active')
        {
            $this->_redirect('employer');
        }
        $this->view->status = $this->sessionUser->status;

    	$userId = Zend_Auth::getInstance()->getIdentity()->user_id;

    	$adapter = Zend_Db_Table_Abstract::getDefaultAdapter();
    	$select = new Zend_Db_Select($adapter);
    	$select->from('staff_employees_mark', array('mark_created' => 'created'))
    		   ->joinInner('staff_employees', 'staff_employees_mark.employee_id = staff_employees.employee_id')
    		   ->where("staff_employees_mark.user_id = $userId")
               ->where("staff_employees_mark.status != 'deleted'")
    		   ->where("staff_employees_mark.mark_type = 'blacklisted'")
    		   ->where("staff_employees.status != 'deleted'");
    	$results = $adapter->fetchAll($select);
    	$this->view->count = count($results);

        $page       = $this->_getParam('p', 1);
        $paginator  = Zend_Paginator::factory($results);
        $paginator->setItemCountPerPage(20);
        $paginator->setCurrentPageNumber($page);
        $this->view->rows = $paginator;

        //session 
        $this->sessionListed->location = 'blacklisted';
    }


    public function listedAction()
    {      
        if($this->sessionUser->status != 'active')
        {
            $this->_redirect('employer');
        }
        $this->view->status = $this->sessionUser->status;

        if($this->getRequest()->isPost())
        {

            $markType = $this->_request->getPost('submit');
            $employeeId = $this->_request->getPost('employee_id');
            $userId = Zend_Auth::getInstance()->getIdentity()->user_id;

            //removing mark type
            if($markType == 'remove-listed')
            {
                $mark = new Application_Model_Tables_Employeesmark();
                $mark->removeMarkType($employeeId);
                $this->_redirect("index/search-view/category/employees/id/$employeeId");
            }
            else
            {
                //check if the employee is already marked but deleted
                $mark = new Application_Model_Tables_Employeesmark();
                $row = $mark->fetchRow($mark->select()->where('employee_id = ?', $employeeId)->where('user_id = ?', $userId)->where("mark_type = 'whitelisted' || mark_type ='blacklisted' ")->where('status = ?', 'deleted'));
                $result = count($row);

                //if there's already a record then restore it
                if($result == 1)
                {
                    $mark->restoreMarkType($employeeId, $markType);
                    $this->_redirect("index/search-view/category/employees/id/$employeeId");     
                }
                else
                //else if not existed, add new
                {
                   //adding mark type
                    if($markType == 'whitelisted')
                    {                
                        $mark = new Application_Model_Tables_Employeesmark();
                        $mark->addMarkType($employeeId, $markType);
                        $this->_redirect("index/search-view/category/employees/id/$employeeId");          
                    }

                    if($markType == 'blacklisted')
                    {                
                        $mark = new Application_Model_Tables_Employeesmark();
                        $mark->addMarkType($employeeId, $markType);
                        $this->_redirect("index/search-view/category/employees/id/$employeeId");
                    }
                }   
            }  

        }
    }


    public function removeListedAction()
    {
        if($this->sessionUser->status != 'active')
        {
            $this->_redirect('employer');
        }
        $this->view->status = $this->sessionUser->status;

        $this->request = $this->getRequest();
        $employeeId = $this->request->getParam('id');

        if(empty($employeeId))
        {
            $this->_redirect('employer/company-profile');
        }

        $mark = new Application_Model_Tables_Employeesmark();
        $mark->removeMarkType($employeeId);

        $location = $this->sessionListed->location;
        $this->_redirect("employees/$location");
    }

}
?>