<?php

class EmployerController extends Zend_Controller_Action
{
	
    
    /**
     * Before dispatching, check the security in general
     */
    public function preDispatch() 
    {
        $this->view->auth = Zend_Auth::getInstance();
        if (!$this->view->auth->hasIdentity()) { 
            $this->_helper->flashMessenger->addMessage('<p class="msg error">Error accessing the resquested page.</p>');
            $this->_redirect('/');
        }
        
        // Check Privilege
        // Controllers and views are accessibleonly by admin
        /*
        if (Zend_Auth::getInstance()->getStorage()->read()->privilege != 'admin') {
            $this->_helper->flashMessenger->addMessage('<p class="msg error">Error accessing the resquested page.</p>');
            $this->_redirect('/');
        }
        **/
    }
    
    
	/**
	 * Initialize action controller here.
	 */
    public function init()
    {
        // Set the flash messenger
		$this->view->flashMessenger = $this->_helper->flashMessenger->getMessages();
        
        $this->sessionUser = new Zend_Session_Namespace("sessionUser");
    }

    
    /**
     * Add employee action
     */
    public function addEmployeeAction()
    {
        // Page title.
        $this->view->headTitle('Add Employee');
        
        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'add-employee-page';  

        $this->view->status = $this->sessionUser->status;
        $this->view->userId = Zend_Auth::getInstance()->getIdentity()->user_id;

        //if not yet activated it will redirect to employer profiles
        if($this->sessionUser->status != 'active')
        {
            $this->_redirect('employer');
        } 

        // $uploadPath = APPLICATION_PATH . "/../public/uploads/profile_pic/";
        // @mkdir("{$uploadPath}test", 0777); 
        if($this->getRequest()->isPost())
        {
            $token = $this->_request->getPost('token');
            if($this->sessionUser->addEmployee == $token)
            {
                $f = new Zend_Filter_StripTags();
                $fname = $f->filter($this->_request->getPost('fname'));
                $mname = $f->filter($this->_request->getPost('mname'));
                $lname = $f->filter($this->_request->getPost('lname'));
                $designation = $f->filter($this->_request->getPost('designation'));
                    $year = $f->filter($this->_request->getPost('year'));
                    $month = $f->filter($this->_request->getPost('month'));
                    $day = $f->filter($this->_request->getPost('day'));
                $lastDate = $year . "-" . $month . "-" . $day;
                $lastSalary = $f->filter($this->_request->getPost('last_salary'));
                $attendance = $f->filter($this->_request->getPost('attendance'));
                $remarks = $f->filter($this->_request->getPost('remarks'));
                $recommendation = $f->filter($this->_request->getPost('recommendation'));
                $unpaidLoan = $f->filter($this->_request->getPost('unpaid_loan'));
                $unpaidAdvance = $f->filter($this->_request->getPost('unpaid_advance'));
                $employmentStatus = $f->filter($this->_request->getPost('employment_status'));
                $employmentAction = $f->filter($this->_request->getPost('employment_action'));

                $formDatas = $this->getRequest()->getPost();
                $formDatas = $this->_helper->filterTags->filter($formDatas);
                $validator = new Zend_Validate_Db_RecordExists(array('table' => Zend_Registry::get('tablePrefix') . 'companies', 'field' => 'company_name'));

                if(empty($fname) || empty($mname) || empty($lname) ||  empty($designation) || empty($lastDate) || empty($lastSalary) || empty($attendance) || empty($remarks) || empty($recommendation) || empty($employmentStatus) || empty($employmentAction))
                {
                    $this->view->flashMessenger[] = "<div class='msg error'>One of the fields are empty</div>";
                    $this->view->formDatas = $formDatas;
                }
                elseif ($validator->isValid($companyName)) 
                {
                    $this->view->flashMessenger[] = "<div class='msg error'>Company Name already existed, please try again.</div>";
                    $this->view->formDatas = $formDatas;
                }
                elseif(!ctype_digit($lastSalary))
                {
                    $this->view->flashMessenger[] = "<div class='msg error'>Invalid Character Type.</div>";
                    $this->view->formDatas = $formDatas;
                }
                else
                {
                    $adapter = new Zend_File_Transfer_Adapter_Http(); 
                    //add validator for the uploaded files
                    /*
                    $adapter->addValidator('IsImage', false)
                            ->addValidator('Size', false, 40000);
                    */
                    $adapter->addValidator('Size', false, 102400)
                            ->addValidator('Extension', false, array('jpg', 'jpeg', 'png'))
                            ->addValidator('ImageSize', false,
                                    array(
                                        'minwidth' => 100,
                                        'maxwidth' => 300,
                                        'minheight' => 100,
                                        'maxheight' => 300
                                    )
                                );
                    //value(name) of file uploaded
                    $photo = $adapter->getFileName();
                    //instantiate the Model Class
                    $employee = new Application_Model_Tables_Employers();

                    //path to uploads/profile_pic
                    $uploadPath = APPLICATION_PATH . "/../public/uploads/profile_pic/";

                    if(!empty($photo))
                    {                    
                        //validate depend on addvalidator
                        if($adapter->isValid())
                        {
                            /* Temp
                            //adding of thumbnail
                            $imageThumbFilename = 'thumb_' . $photoName;
                            $formDatas['photo_thumbnail'] $imageThumbFilename;
                            */
                            //function for inserting and updating photoname & at the same time return the photoname(id)
                            $photoName = $employee->addEmployee($formDatas, $photo);

                            //get the name, convert it to array and remove the last element of the array
                            $tmpName = array_slice(explode(".", $photoName), 0, -1);
                            //implode the array which result to the name of the folder
                            $folderName = implode("", $tmpName);
                            //make the folder name (base on the id of the user)
                            $createFolder = @mkdir("{$uploadPath}{$folderName}", 0777);

                            //destination of the uploaded
                            $adapter->setDestination("{$uploadPath}{$folderName}/");
                            //rename the file to be uploaded
                            $adapter->addFilter('Rename', $photoName);
                            //upload the file running the filter
                            $adapter->receive();
                            
                            // Get the file info i.e. tmp name, file name etc    
                            $filenames = $adapter->getFileInfo();

                            // Get the first uploaded file info   
                            if (trim($filenames['uploadedfile']['name']) != null) 
                            {

                                // The first image file
                                $imageFilename  = $filenames['uploadedfile']['name'];

                                // Save to formDatas
                                $formDatas['uploadedfile'] = $imageFilename;

                                // Create thumbnail name
                                $imageThumbFilename = 'thumb_' . $photoName;
                                
                                // Save to formDatas
                                $formDatas['image_thumb_filename'] = $imageThumbFilename;
                                
                                // Crop the image
                                $this->_helper
                                     ->Crop
                                     ->imageCrop(100, 87, "$uploadPath/$folderName/$imageFilename", "$uploadPath/$folderName/$imageThumbFilename");
                            }

                            
                            $this->_helper->flashMessenger->addMessage("<div class='msg done'>Employee record Succesfully added.</div>");
                            $this->_redirect('employer/list-employees');
                        }
                        else
                        {
                            $this->view->flashMessenger[] = "<div class='msg error'>Either the file is not an image, it exceeds the maximum upload size or maximum image dimension.</div>";
                            $this->view->formDatas = $formDatas;
                        }
                    }
                    else
                    {
                        $photoName = $employee->addEmployee($formDatas, $photo);
                        
                        //photo_name returns the id of the data if the photo is empty
                        $folderName = $photoName;
                        //creating a folder for photo
                        $createFolder = @mkdir("{$uploadPath}{$folderName}", 0777);
                        $this->_helper->flashMessenger->addMessage("<div class='msg done'>Employee record Succesfully added.</div>");
                        $this->_redirect('employer/list-employees');
                    }
                }
            }
        }
        $token = uniqid();
        $this->view->token = $token;
        $this->sessionUser->addEmployee = $token;
    }

    /**
     * List of Employees Action
     */
    public function listEmployeesAction()
    {
        $this->view->headTitle('List of Employees');
        $this->view->bodyId = 'list-employee-page';  

        if($this->sessionUser->status != 'active')
        {
            $this->_redirect('employer');
        }
        $this->view->status = $this->sessionUser->status;

        $id = Zend_Auth::getInstance()->getIdentity()->user_id;
        $this->view->userId = $id;

        $employees = new Application_Model_Tables_Employers;
        $row = $employees->fetchAll($employees->select()->where("user_id = ". $id)->where("status = 'not-deleted'")->order('created DESC'));
        //converting the result into the array
        $this->view->query_result = $row->toArray();
        //checking the number of results
        $this->view->num_rows = $row->count();

        // Zend paginator processs
        $page       = $this->_getParam('p', 1);
        $paginator  = Zend_Paginator::factory($row);
        $paginator->setItemCountPerPage(20);
        $paginator->setCurrentPageNumber($page);
        //sending data to view
        $this->view->data = $paginator;

        $token = uniqid();
        $this->view->token = $token;
        $this->sessionUser->employeeToken = $token;
    }
    

    /**
     * Delete Employee Action
     */
    public function deleteEmployeeAction()
     {
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        if($this->sessionUser->status != 'active')
        {
            $this->_redirect('employer');
        }
        $this->view->status = $this->sessionUser->status;

        $this->request = $this->getRequest();
        $id = $this->request->getParam('id');
        $token = $this->request->getParam('token');
        if(empty($id) || empty($token))
        {
            $this->_redirect('employer');
        }
        if($this->sessionUser->employeeToken == $token)
        {
            $validate = $this->_helper->validateEmployee->isEmployee($userId, $id);
            if($validate == false)
            {
                $this->_redirect('employer/list-employees');
            }
            
            $employees = new Application_Model_Tables_Employers();
            $where = $employees->getAdapter()->quoteInto('employee_id = ' . $id);
            $data = array('status' => 'deleted');
            $employees->update($data, $where);
            $this->_redirect('employer/list-employees');
        }
     }


    /**
     * Deleted Employee Action
     */
    public function deletedEmployeeAction() 
    {
        // Page Title.
        $this->view->headTitle('Deleted Employees');

        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'list-employee-page';

        //if not yet activated it will redirect to employer profiles
        if($this->sessionUser->status != 'active')
        {
            $this->_redirect('employer');
        }
        $this->view->status = $this->sessionUser->status;

        $id = Zend_Auth::getInstance()->getIdentity()->user_id;
        $this->view->userId = $id;
        $employees = new Application_Model_Tables_Employers();
        
        //query of all deleted employees
        $employeeRow = $employees->fetchAll($employees->select()->where("user_id = " . $id)->where("status = 'deleted'"));
        
        //number of results
        $this->view->numRows = count($employeeRow);

        // Zend paginator processs
        $page       = $this->_getParam('p', 1);
        $paginator  = Zend_Paginator::factory($employeeRow);
        $paginator->setItemCountPerPage(20);
        $paginator->setCurrentPageNumber($page);
        //sending data to view
        $this->view->data = $paginator;
    }

     /**
     * Edit Employee Action
     */
    public function editEmployeeAction()
     {
         // Page title.
        $this->view->headTitle('Edit Employee');
        
        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'edit-employee-page'; 
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        $this->view->userId = $userId;
        //if not yet activated it will redirect to employer profiles
        if($this->sessionUser->status != 'active')
        {
            $this->_redirect('employer');
        }
        $this->view->status = $this->sessionUser->status;
        
        $this->request = $this->getRequest();
        $id = $this->request->getParam('id');
        if(empty($id))
        {
            $this->_redirect('employer');
        }

        $validate = $this->_helper->validateEmployee->isEmployee($userId, $id);
        if($validate == false)
        {
            $this->_redirect('employer/list-employees');
        }
        //instantiating
        $employee = new Application_Model_Tables_Employers();
        //storing the result of query in the variable row that the view(edit-employee.phtml) can access
        $this->view->row = $employee->fetchRow($employee->select()->where('employee_id = '.$id, 1));

        if($this->getRequest()->isPost())
        {
            $token = $this->_request->getPost('token');
            if($this->sessionUser->editEmployee == $token) 
            {
                $firstName = $this->_request->getPost('fname');
                $middleName = $this->_request->getPost('mname');
                $lastName = $this->_request->getPost('lname');
                $designation = $this->_request->getPost('designation');
                    $day = $this->_request->getPost('day');
                    $month = $this->_request->getPost('month');
                    $year = $this->_request->getPost('year');
                $lastDate = $year . "-" . $month . "-" . $day;
                $lastSalary = $this->_request->getPost('last_salary');
                $unpaidLoan = $this->_request->getPost('unpaid_loan');
                $unpaidAdvance = $this->_request->getPost('unpaid_advance');
                $attendance = $this->_request->getPost('attendance');
                $employmentStatus = $this->_request->getPost('employment_status');
                $employmentAction = $this->_request->getPost('employment_action');
                $remarks = $this->_request->getPost('remarks');
                $recommendation = $this->_request->getPost('recommendation');
                
                $formDatas = $this->getRequest()->getPost();
                $formDatas = $this->_helper->filterTags->filter($formDatas);
                if(empty($firstName) || empty($middleName) || empty($lastName) || empty($designation) || empty($lastDate) || empty($lastSalary) || empty($attendance) || empty($employmentStatus) || empty($employmentAction) || empty($remarks) || empty($recommendation))
                {              
                    $this->view->flashMessenger[] = "<div class='msg error'>One of the fields are empty.</div>";                
                    $this->view->formDatas = $formDatas;
                }
                elseif(!ctype_digit($lastSalary) || !ctype_digit($unpaidLoan) || !ctype_digit($unpaidAdvance))
                {
                    $this->view->flashMessenger[] = "<div class='msg error'>Invalid Character Type.</div>";
                    $this->view->formDatas = $formDatas;
                }                
                else
                {                                
                    $employee = new Application_Model_Tables_Employers();
                    //file transfer
                    $adapter = new Zend_File_Transfer_Adapter_Http(); 
                    //adding a Validator to be checked by isValid() function
                    /*
                    $adapter->addValidator('IsImage', false)
                            ->addValidator('Size', false, 40000);
                    */
                    $adapter->addValidator('Size', false, 102400)
                            ->addValidator('Extension', false, array('jpg', 'jpeg', 'png'))
                            ->addValidator('ImageSize', false,
                                    array(
                                        'minwidth' => 100,
                                        'maxwidth' => 300,
                                        'minheight' => 100,
                                        'maxheight' => 300,
                                    )
                                );
                            //rename file before uploading
                            //->addFilter('Rename', $f_name.".jpg"); 
                    //get value/filename of file upload to be checked
                    $uploadedfile = $adapter->getFileName();

                    //uploadpath
                    $uploadPath = APPLICATION_PATH . "/../public/uploads/profile_pic/";

                    //if empty photo
                    if(empty($uploadedfile))        
                    {
                        $employee->updateEmployee($formDatas, $uploadedfile, $id);
                        $this->_helper->flashMessenger->addMessage("<div class='msg done'>Employee record Succesfully updated.</div>");
                        $this->_redirect('employer/list-employees');
                    }else{
                        if($adapter->isValid())
                        {
                            //function for inserting and updating photoname & at the same time return the photoname(id)
                            $photoName = $employee->updateEmployee($formDatas, $uploadedfile, $id);
                            
                            //uploaded file Destination public/uploads
                            $adapter->setDestination("{$uploadPath}{$id}/");
                            //rename the file to be uploaded
                            $adapter->addFilter('Rename', $photoName);
                            $this->_helper->flashMessenger->addMessage("<div class='msg done'>Employee record Succesfully updated.</div>");
                            //upload the file running the filter
                            $adapter->receive();
                            
                            // Get the file info i.e. tmp name, file name etc    
                            $filenames = $adapter->getFileInfo();

                            // Get the first uploaded file info   
                            if (trim($filenames['uploadedfile']['name']) != null) 
                            {

                                // The first image file
                                $imageFilename  = $filenames['uploadedfile']['name'];

                                // Save to formDatas
                                $formDatas['uploadedfile'] = $imageFilename;

                                // Create thumbnail name
                                $imageThumbFilename = 'thumb_' . $photoName;
                                
                                // Save to formDatas
                                $formDatas['image_thumb_filename'] = $imageThumbFilename;
                                
                                
                                // Crop the image
                                $this->_helper
                                     ->Crop
                                     ->imageCrop(100, 87, "$uploadPath/$id/$imageFilename", "$uploadPath/$id/$imageThumbFilename");
                            }
                            
                            $this->_redirect('employer/list-employees');
                        }
                        else
                        {
                            echo "<script type='text/javascript'>alert('Either the file is not an image or it exceeds the maximum upload size.')</script>";
                        }                   
                    }
                }  
            }     
        }
        $token = uniqid();
        $this->view->token = $token;
        $this->sessionUser->editEmployee = $token;
    }


    /**
     * View Employee Action
     */
    public function viewEmployeeAction()
    {
        $this->view->headTitle('Employee Profile');
        $this->view->bodyId = 'view-employee-page';
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id; 
        $this->view->userId = $userId;
        //if not yet activated it will redirect to employer profiles
        if($this->sessionUser->status != 'active')
        {
            $this->_redirect('employer');
            $this->view->status = 'inactive';
        }
        $this->view->status = $this->sessionUser->status;

        $this->request = $this->getRequest();
        //getting value of parameter id
        $id = $this->request->getParam('id');
        if(empty($id))
        {
            $this->_redirect('employer');
        }

        $validate = $this->_helper->validateEmployee->isEmployee($userId, $id);
        if($validate == false)
        {
            $this->_redirect('employer/list-employees');
        }

        //instantiating
        $employee = new Application_Model_Tables_Employers();
        //storing data to variable to be use on views and controller for getting the id of the user and company
        $employeeRow = $employee->fetchRow($employee->select()->where('employee_id = '.$id, 1));
        //storing the result of query in the variable row that the view(edit-employee.phtml) can access
        $this->view->row = $employeeRow;

        //store the user id
        $companyId = $employeeRow['user_id'];
        //instantiating Companies Table for determining table
        $company = new Application_Model_Tables_Companies();
        $this->view->companyRow = $company->fetchRow($company->select()->where('user_id = ' . $companyId, 1));

    }


    /**
     * Index / Dashboard
     */
    public function indexAction()
    {
        // Page title.
        $this->view->headTitle('Company Profile');
        
        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'employer-profile-page'; 

        //user id of user
        $id = Zend_Auth::getInstance()->getIdentity()->user_id;
        $this->view->userId = $id;
        //fetch status of the user and put it on a session
        
        $users = new Application_Model_Tables_Users();
        $status = $users->fetchRow($users->select()->where('user_id = ' . $id, 1));
        $this->view->memberSince = $status->created;

        if($status->status != 'active')
        {
            $this->sessionUser->status = 'inactive';
            $this->view->status = 'inactive';
        }
        else
        {
            $this->sessionUser->status = 'active';
            $this->view->status = 'active';
        }
        
        $user = new Application_Model_Tables_Companies();
        $userRow = $user->fetchRow($user->select()->where('user_id = '.$id, 1));       
        $this->view->userRow = $userRow;

        $employees = new Application_Model_Tables_Employers();
        $employeesRow = $employees->fetchAll($employees->select()->where("user_id = ". $id . " && status='not-deleted'", 'NEW')->order('created DESC')->limit(5, 0));
        $this->view->employeesCount = $employeesRow->count();
        $this->view->employeesRow = $employeesRow;

        $announcement = new Application_Model_Tables_Announcements();
        $announcementRows = $announcement->fetchNotDeleted();
        if($announcementRows)
        {
            $this->view->announcementCount = $announcementRows->count();
            $page       = $this->_getParam('p', 1);
            $paginator  = Zend_Paginator::factory($announcementRows);
            $paginator->setItemCountPerPage(3);
            $paginator->setCurrentPageNumber($page);
            $this->view->announcementRows = $paginator;
        }

        //for fetching the required fields
        $list = array('Company Name' => 'company_name', 'Company Address' => 'company_address', 'ZIP code' => 'zipcode', 'Company Phone' => 'company_phone', 'Company Fax Number' => 'company_fax', 'Company Email', 'company_email', 'Company Logo' => 'company_pic', 'First Name' => 'first_name', 'Middle Name' => 'middle_name', 'Last Name' => 'last_name', 'Designation' => 'designation');
        $errors = array();
        if($userRow)
        {
            foreach($userRow as $key => $value)
            {
                if($value == '0' || $value == 'default.jpg' || empty($value))
                {
                    foreach($list as $listKey => $listValue)
                    {
                        if($listValue == $key)
                        {
                            $errors[] = $listKey;                        
                        }
                    }
                }            
            }
            $this->view->errors = $errors;
            $this->view->errorsCount = count($errors);
        }
        $token = uniqid();
        $this->view->token = $token;
        $this->sessionUser->employeeToken = $token;
    }


    /**
     * View Profile
     */
    public function profileAction()
    {
        $this->view->headTitle('Company Profile');   
        $this->view->bodyId = 'employer-profile-page'; 

        $id = Zend_Auth::getInstance()->getIdentity()->user_id;
        if(empty($id))
        {
            $this->_redirect('/');
        }
        $users = new Application_Model_Tables_Users();
        $status = $users->fetchRow($users->select()->where('user_id = ' . $id, 1));
        
        $this->view->userId = $id;
        if($status->status != 'active')
        {
            $this->sessionUser->status = 'inactive';
            $this->view->status = 'inactive';
        }
        else
        {
            $this->sessionUser->status = 'active';
            $this->view->status = 'active';
        }

        $user = new Application_Model_Tables_Companies(); 
        $userRow = $user->fetchRow($user->select()->where('user_id = '.$id, 1));            
        $this->view->userRow = $userRow;

        $employees = new Application_Model_Tables_Employers();
        $employeesRow = $employees->fetchAll($employees->select()->where("user_id = ". $id . " && status='not-deleted'", 'NEW')->order('created DESC')->limit(5, 0));
        $this->view->employeesRow = $employeesRow;
        $this->view->employeesCount = $employeesRow->count();
    
        $list = array('Company Name' => 'company_name', 'Company Address' => 'company_address', 'ZIP code' => 'zipcode', 'Company Phone' => 'company_phone', 'Company Fax Number' => 'company_fax', 'Company Email', 'company_email', 'Company Logo' => 'company_pic', 'First Name' => 'first_name', 'Middle Name' => 'middle_name', 'Last Name' => 'last_name', 'Designation' => 'designation');
        $errors = array();
        foreach($userRow as $key => $value)
        {
            if($value == '0' || $value == 'default.jpg' || empty($value))
            {
                foreach($list as $listKey => $listValue)
                {
                    if($listValue == $key)
                    {
                        $errors[] = $listKey;                        
                    }
                }
            }            
        }
        $this->view->errors = $errors;
        $this->view->errorsCount = count($errors);

        $token = uniqid();
        $this->view->token = $token;
        $this->sessionUser->employeeToken = $token;
    }


    public function editProfileAction()
    {
        $this->view->headTitle('Edit Profile');
        $this->view->bodyId = 'edit-employer-page'; 
           
        $this->view->status = $this->sessionUser->status;    
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        $this->view->userId = $userId;

        if(empty($userId))
        {
            $this->_redirect("employer");
        }

        $employer = new Application_Model_Tables_Companies();
        $row = $employer->fetchRow($employer->select()->where('user_id = ' . $userId, 1));
        $this->view->row = $row;
        $origCompanyName = $row['company_name']; 
        if($this->getRequest()->isPost())
        {
            $token = $this->_request->getPost('token');
            if($this->sessionUser->editEmployer == $token)
            {
                $companyName = $this->_request->getPost('company_name');
                $companyAddress  = $this->_request->getPost('company_address');
                $zipcode = $this->_request->getPost('zipcode');
                $companyPhone = $this->_request->getPost('company_phone');
                $companyFax = $this->_request->getPost('company_fax');
                $firstName = $this->_request->getPost('first_name');
                $middleName = $this->_request->getPost('middle_name');
                $lastName = $this->_request->getPost('last_name');
                $designation = $this->_request->getPost('designation');            
                $typeOfCompany = $this->_request->getPost('type_of_company');

                $formDatas = $this->getRequest()->getPost();
                
                $formDatas = $this->_helper->filterTags->filter($formDatas);
                $validator = new Zend_Validate_Db_RecordExists(array('table' => Zend_Registry::get('tablePrefix') . 'companies', 'field' => 'company_name'));
                
                if(empty($companyName) || empty($companyAddress) || empty($companyPhone) || empty($companyFax) || empty($firstName) || empty($middleName) || empty($lastName) || empty($designation) || empty($typeOfCompany) || empty($zipcode) )
                {
                    $this->view->flashMessenger[] = "<div class='msg error'>One of the fields are empty!</div>";
                    $this->view->formDatas = $formDatas;
                }
                elseif ($validator->isValid($companyName) && $companyName != $origCompanyName) 
                {
                    $this->view->flashMessenger[] = "<div class='msg error'>Company Name already existed, please try again.</div>";
                    $this->view->formDatas = $formDatas;
                }
                elseif(!ctype_digit($zipcode))
                {
                    $this->view->flashMessenger[] = "<div class='msg error'>Zip Code must be integer only.</div>";
                    $this->view->formDatas = $formDatas;
                }
                else
                {                
                    $errors = array();
                    
                    $companies = new Application_Model_Tables_Companies();
                    
                    //Company Logo
                    $adapterLogo = new Zend_File_Transfer_Adapter_Http();
                    
                    $adapterLogo->addValidator("Size", false, 1024000)
                                ->addValidator('Extension', false, array('jpg', 'jpeg', 'png'))
                                ->addValidator('ImageSize', false,
                                    array(
                                        'minwidth' => 10,
                                        'maxwidth' => 3000,
                                        'minheight' => 10,
                                        'maxheight' => 3000
                                    )
                                );
                    
                    
                    $fileLogo = $adapterLogo->getFileName();
                    
                    if($fileLogo != NULL) { 
                        if (!$adapterLogo->isValid()) { 
                            $errors['logo'] = "<div class='msg error'>Company Logo is not an image or it exceeds the maximum upload size.</div>";
                        }
                    }

                    if(empty($errors))
                    {
                        $companies->updateCompany($formDatas);
                        
                        $this->_helper->flashMessenger->addMessage('<p class="msg done">Profile Succesfully Updated.</p>');
                        
                        if($adapterLogo->isValid())
                        {
                            
                            $companies->photoName($userId, $fileLogo);
                            
                            $filename = $adapterLogo->getFileName();

                            $fileInfo = $adapterLogo->getFileInfo();

                            $fileNameInfo = pathinfo($fileInfo['uploadedfile']['name']);

                            //Rename Image
                            $formDatas['photo_name'] = $userId . '.' . $fileNameInfo['extension'];
                            
                            $uploadPathLogo = APPLICATION_PATH . "/../public/uploads/company_pic/{$userId}";
                        
                            @mkdir($uploadPathLogo, 0777);
                            @chmod($uploadPathLogo, 0777);
                
                             
                            $adapterLogo->setDestination("public/uploads/company_pic/{$userId}/");
                            //renaming/updating photo

                            $adapterLogo->addfilter("Rename", $formDatas['photo_name']);
                            
                            $adapterLogo->receive();
                            
                            // Get the file info i.e. tmp name, file name etc    
                            $filenames = $adapterLogo->getFileInfo();
                            // Get the first uploaded file info   
                            
                            if (trim($filenames['uploadedfile']['name']) != null) 
                            {
                                
                                // The first image file
                                $imageFilename  = $filenames['uploadedfile']['name'];

                                // Create thumbnail name
                                $imageThumbFilename = 'thumb_' . $formDatas['photo_name'];
                                
                                // Save to formDatas
                                $formDatas['image_thumb_filename'] = $imageThumbFilename;
                                
                                // Crop the image
                                $this->_helper
                                     ->Crop
                                     ->imageCrop(100, 80, "$uploadPathLogo/$imageFilename", "$uploadPathLogo/$imageThumbFilename");
                            }
                        }
                        
                        $companies->updateCompany($formDatas);
                        $this->_helper->flashMessenger->addMessage('<p class="msg done">Profile Succesfully Updated.</p>');
                        $this->_redirect('employer/edit-profile');

                    }else{
                        
                        foreach ($errors as $value) {
                            $this->view->flashMessenger[] = $value;
                        }
                    }
                    
                    if(empty($errors['loa']) and empty($errors['bp'])){
                        $companies->updateCompany($formDatas);
                        $this->_helper->flashMessenger->addMessage('<p class="msg done">Profile Succesfully Updated.</p>');
                        $this->_redirect('employer/edit-profile');
                    }
                }
            }
        }
        $token = uniqid();
        $this->view->token = $token;
        $this->sessionUser->editEmployer = $token;
    }

    //function for edit employer/user username and password
    public function editAccountAction()
    {
        // Page title.
        $this->view->headTitle('Edit Account');
        
        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'edit-employer-account-page'; 

        $this->view->status = $this->sessionUser->status;
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        $this->view->userId = $userId;

        if(empty($userId))
        {
            $this->_redirect('employer');
        }

        $employer = new Application_Model_Tables_Users();
        //fetch data for the first instance of viewing the page
        $this->view->row = $employer->fetchRow($employer->select()->where('user_id = ' . $userId, 1));

        //if change username submit button is submitted
        if($this->getRequest()->getPost('username_submit'))
        {
            $this->_redirect('employer/edit-employer-account');
            /*
            $token = $this->_request->getPost('token');
            if($this->sessionUser->editAccount == $token)
            {
                $username = $this->_request->getPost('new_username');
                if(!empty($username))
                {
                    $formDatas = $this->getRequest()->getPost();
                    $formDatas = $this->_helper->filterTags->filter($formDatas);
                    //helper to change username and check if the username is already existed
                    $errors = $this->_helper->validatesAccount->changeUsername($formDatas);
                    if($errors == null)
                    {
                        $formDatas['id'] = $userId;
                        $user = new Application_Model_Tables_Users();
                        $company = new Application_Model_Tables_Companies();
                        //update username (function in Users and Companies Model)
                        $user->updateUsername($formDatas);
                        $company->updateUsername($formDatas);

                        $this->view->flashMessenger[] = "<div class='msg done'>Username Succesfully Changed!</div>";
                        //after changing the username, fetch again the data to change the display data
                        $this->view->row = $employer->fetchRow($employer->select()->where('user_id = ' . $userId, 1));
                    }
                    else
                    {
                        //display errors
                        $message = '<ul>';
                        foreach($errors as $error) {
                            $message.= '<li>' . $error . '</li>';
                        }
                        $message.= '</ul>';
                        // $this->_helper->flashMessenger->addMessage('<div class="msg error">' . $message . '</div>');
                        $this->view->flashMessenger[] = '<div class="msg error">' . $message . '</div>';  
                        $this->view->formDatas = $formDatas;
                    }                    
                    
                }
                else
                {
                    $this->view->flashMessenger[] = "<div class='msg error'>User name field is empty.</div>";
                }
            }
            */
        }

        //if change password submit button is submitted
        if($this->getRequest()->getPost('password_submit'))
        {
            $token = $this->_request->getPost('token');
            if($this->sessionUser->editAccount == $token)
            {
                $oldPass = $this->_request->getPost('old_password');
                $newPass = $this->_request->getPost('new_password');
                $newPass2 = $this->_request->getPost('new_password2');
                if(empty($oldPass) || empty($newPass) || empty($newPass2))
                {
                    echo "<script type='text/javascript'>alert('One of the Password field is empty!')</script>";
                }
                else
                {
                    $formDatas = $this->getRequest()->getPost();
                    $errors = $this->_helper->validatesAccount->changePassword($formDatas);
                    if($errors == null)
                    {
                        $formDatas['id'] = $id;
                        $user = new Application_Model_Tables_Users();
                        $password = $user->fetchRow($user->select()->where('user_id = ' . $userId, 1));
                        $oldPassword = md5($oldPass);
                        $currentPassword = $password['password'];
                        if($currentPassword != $oldPassword)
                        {
                            $this->view->flashMessenger[] = '<div class="msg error">Old Password does not Match.</div>';                ;
                        }
                        else
                        {
                            $user = new Application_Model_Tables_Users();
                            $user->updatePassword($formDatas);
                            $this->view->flashMessenger[] = "<div class='msg done'>Password Succesfully Changed!</div>";
                            //$this->_redirect('employer');
                        }
                    }
                    else
                    {
                        //display errors
                        $message = '<ul>';
                        foreach($errors as $error) {
                            $message.= '<li>' . $error . '</li>';
                        }
                        $message.= '</ul>';
                        // $this->_helper->flashMessenger->addMessage('<div class="msg error">' . $message . '</div>');
                        $this->view->flashMessenger[] = '<div class="msg error">' . $message . '</div>';  
                        $this->view->formDatas = $formDatas;
                    }  
                }
            }
        }
        $token = uniqid();
        $this->view->token = $token;
        $this->sessionUser->editAccount = $token;
    }
    

}
?>