<?php

class IndexController extends Zend_Controller_Action
{
	
	/**
	 * Initialize action controller here
	 */
    public function init()
    {
        // Set the flash messenger
		$this->view->flashMessenger = $this->_helper->flashMessenger->getMessages();

        $this->sessionUser = new Zend_Session_Namespace("sessionUser");

    }


    /**
     * Index page.
     */
    public function indexAction()
    {
        //get the cache we registered at the bootstrap
        // $cache = Zend_Registry::get('index');
        
        // if (!$result = $cache->load('index')) {
            
        
        $this->view->headTitle('Welcome');
        $this->view->bodyId = 'index-page';

        $users = new Application_Model_Tables_Companies();
        $usersSelect = $users->fetchActiveCompanies();
        $this->view->usersRow = $users->fetchIndexCompanies();
        //total number of companies
        $this->view->usersCount = $usersSelect->count();

        $employees = new Application_Model_Tables_Employers();
        $employeesSelect = $employees->select()->where("status != 'deleted'")->where("photo != 'default.jpg'")->order(new Zend_Db_Expr('RAND()'))
     
                ->limit(6, 0);
        $employeesRow = $users->fetchAll($employeesSelect);
        $this->view->employeesRow = $employeesRow;

        $employeesSelect2 = $employees->select()->where("status != 'deleted'")->order('created')->limit(6, 0);
        $employeesRow2 = $users->fetchAll($employeesSelect2);
        $this->view->employeesRow2 = $employeesRow2;
        
        $employeesCount = $employees->fetchAll($employees->select()->where("status != 'deleted'"));
        $this->view->employeesCount = $employeesCount->count();
        
        // $auth = Zend_Auth::getInstance();
        // if($auth->hasIdentity())
        // {
        //     $this->view->login = 1;
        // }
        // else
        // {
        //     $this->view->login = 0;
        // }
        
        // } else {
            
        //     $this->_helper->layout->disableLayout();
            
        //     $this->_helper->viewRenderer->setNoRender();
            
        //     echo $result['data'];
            
        // }
    }

    
	/**
	 * Handles login validation
	 */
    public function loginAction()
    {
        
        if ($this->getRequest()->isPost()) {
            $this->view->headTitle('Log In');
            
    		// Collect the data from the user.
    		$f = new Zend_Filter_StripTags();
    		
            $username = $f->filter($this->_request->getPost('username'));
    		$password = $this->_request->getPost('password');
    		
    		if (empty($username)) {
    			$this->_helper
                ->flashMessenger
                ->addMessage('<p class="msg error">The password you have entered is incorrect. ' .
                '<a href="#">Forgot password?</a></p>');

                $this->_redirect('pages/login');

    		} else {

    			$user = new Application_Model_Tables_Users();
                $result = $user->fetchRow($user->select()->where('username = ?', $username)->where("deleted != 'no' "));

                if(count($result) > 0)
                {
                    $this->_helper
                    ->flashMessenger
                    ->addMessage('<p class="msg error">The details you have entered is incorrect. ' .
                    '<a href="recovery">Forgot password?</a></p>');
                    $this->_redirect('pages/login');    
                }

                $rows = $user->fetchRow($user->select()->where('username = ?', $username));

                    // Get the default adapter  
        			$dbAdapter		= Zend_Db_Table::getDefaultAdapter();
        			// Get the prefix
        			$dbTableName 	= Zend_Registry::get('tablePrefix') . 'users';
        			
        			// Use advance authentication, with status = active
        			$authAdapter	= new Zend_Auth_Adapter_DbTable($dbAdapter);
        			
        			$authAdapter->setTableName($dbTableName);
        			$authAdapter->setIdentityColumn('username');
        		 	$authAdapter->setCredentialColumn('password');
        		 	// $authAdapter->set
        		 	
        			// Set the input credential values to authenticate against.
        			$authAdapter->setIdentity($username);
        			$authAdapter->setCredential(md5($password));
        			

        			// Do the authentication.
        			$auth 	= Zend_Auth::getInstance();
        			$result = $auth->authenticate($authAdapter);
        			
        			if ($result->isValid()) {    

                            $remember = $this->_request->getPost('remember');
                            $time = time()+ 60 * 60 * 24 * 3;
                            if($remember == 1)
                            {
                                if (isset($_COOKIE['rememberUsername'])) {
                                    $_COOKIE['rememberUsername'] = '';
                                    setcookie('rememberUsername', null, 0, '/');
                                    $_COOKIE['rememberUsername'] = $username;
                                    setcookie('rememberUsername', $username, $time, '/');
                                }
                                else {
                                    $_COOKIE['rememberUsername'] = $username;
                                    setcookie('rememberUsername', $username, $time, '/');
                                    $_COOKIE['rememberUsername'] = $username;
                                }
                                Zend_Session::rememberMe($time);
                            }
                            else
                            {
                                if(isset($_COOKIE['rememberUsername']))
                                {
                                    setcookie('rememberUsername', null, 0, '/');
                                    $_COOKIE['rememberUsername'] = '';
                                }
                                Zend_Session::ForgetMe();
                            }
            				// Success: store database row to auth's storage.
            				// System. (Not the password though!).
            				$data = $authAdapter->getResultRowObject(null, 'password');
                            // fetch object data from database
                            $user = $authAdapter->getResultRowObject();
            				$auth->getStorage()->write($data);

                            $authStorage = new Zend_Session_Namespace('authstorage');
                            $authStorage->member = $auth->getStorage()->read();
                            
                            $users = new Application_Model_Tables_Users();
                            $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
                            $lastLogin = $users->updateLastLogin($userId);

                            
            				$this->_helper->flashMessenger->addMessage('<p class="msg done">Successfully log in.</p>');
            				$this->_redirect('employer');
        				
        			} else {
        				// Failure: clear database row from session.
        				$this->_helper->flashMessenger->addMessage('<p class="msg error">The password you have entered is incorrect.</p>');
        				$this->_redirect('pages/login');
                    }
    		}
        }else{
            $this->_redirect('pages/login');
        }
	}
	 
 	
	/**
	 * Logout action
	 */
	public function logoutAction() 
	{
        $authSession = new Zend_Session_Namespace('authstorage');
        unset($authSession->member);
        Zend_Auth::getInstance()->clearIdentity();
        $this->_redirect('Index');
	}

    /**
    *   Search function
    */

    public function searchAction()
    {
        
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        if($userId == NULL)
        {
            $this->_helper->flashMessenger->addMessage('<p class="msg error">You need to be login to view the search results.</p>');
            $this->_redirect('pages/login');
        }
        
        // Page title.
        $this->view->headTitle('Search');
        
        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'search-page'; 

        //session status
        $this->view->status = $this->sessionUser->status;

        $f = new Zend_Filter_StripTags();

        //if click search
        if($this->getRequest()->isPost())
        {           

            $category = $f->filter($this->_request->getPost('categories'));
            $searchString= $f->filter($this->_request->getPost('search_string'));            
            $searchString01 =$f->filter($this->_request->getPost('search_string_01'));
            if($category && (!empty($searchString) || !empty($searchString01)) )
            {
                if($category == "companies"){
                    if($searchString == 'Company Name' || $searchString == 'Enter company name...')
                    {
                        $searchString = '';
                    }
                    $adapter = Zend_Db_Table_Abstract::getDefaultAdapter();
                    $select = new Zend_Db_Select($adapter);
                    $select->from('staff_companies')
                           ->joinInner('staff_users', 'staff_users.user_id = staff_companies.user_id')
                           ->where("staff_companies.company_name LIKE ? OR staff_companies.company_address LIKE ?", "%{$searchString}%")
                           ->where("staff_companies.status != 'deleted' && staff_users.status != 'inactive'");                           
                    $results = $adapter->fetchAll($select);                   
                }else{                    
                    //empty input field if the value is default
                    if($searchString01 == 'First Name' || $searchString01 == "Enter first name...")
                    {
                        $searchString01 = '';
                    }
                    if($searchString == 'Last Name' || $searchString == "Enter last name...")
                    {
                        $searchString = '';
                    }

                    $adapter = Zend_Db_Table_Abstract::getDefaultAdapter();
                    $select = new Zend_Db_Select($adapter);
                    if(!empty($searchString01) && !empty($searchString))//if both first name and last name is filled
                    {   
                        $select->from('staff_employees', array('employee_id','first_name', 'middle_name', 'last_name', 'designation', 'created', 'photo'))
                               ->joinInner('staff_companies', 'staff_employees.user_id = staff_companies.user_id', array('company_name'))
                               ->where('staff_employees.first_name LIKE ?', "%{$searchString01}%")
                               ->where('staff_employees.last_name LIKE ?', "%{$searchString}%")
                               ->where("staff_companies.status != 'deleted'")
                               ->where("staff_employees.status != 'deleted' ");
                        $results = $adapter->fetchAll($select);
                    }
                    elseif(empty($searchString01))//if empty first name
                    {
                        
                        $select->from('staff_employees', array('employee_id','first_name', 'middle_name', 'last_name', 'designation', 'created', 'photo'))
                               ->joinInner('staff_companies', 'staff_employees.user_id = staff_companies.user_id', array('company_name'))
                                ->where('staff_employees.last_name LIKE ?', "%{$searchString}%")
                                ->where("staff_companies.status != 'deleted'")
                                ->where("staff_employees.status != 'deleted' ");
                        $results = $adapter->fetchAll($select);
                    }
                    else//find last name
                    {
                        $select->from('staff_employees', array('employee_id','first_name', 'middle_name', 'last_name', 'designation', 'created', 'photo'))
                               ->joinInner('staff_companies', 'staff_employees.user_id = staff_companies.user_id', array('company_name'))
                                ->where('staff_employees.first_name LIKE ?', "%{$searchString01}%")
                                ->where("staff_companies.status != 'deleted'")
                                ->where("staff_employees.status != 'deleted' ");
                        $results = $adapter->fetchAll($select);
                    }
                }
                
                //inserting search string and category to session for the pagination, because if the user clicks the next page it is not a post and eventually the category and search string will be null
                $this->sessionUser->category = $category;
                $this->sessionUser->searchString = $searchString;
                $this->sessionUser->searchString01 = $searchString01;
            }
        }
        //next page - pagination (probably)
        else
        {                
                //this came from the post data after initiating the first search the session will get the value of the category and search string
                if(isset($this->sessionUser->category) && isset($this->sessionUser->searchString))
                {
                    $category = $this->sessionUser->category;
                    $searchString = $this->sessionUser->searchString;
                }
                else
                {
                    $this->_redirect('Index');
                }

                 if($category == "companies")
                 {
                    $adapter = Zend_Db_Table_Abstract::getDefaultAdapter();
                    $select = new Zend_Db_Select($adapter);
                    $select->from('staff_companies')
                           ->joinInner('staff_users', 'staff_users.user_id = staff_companies.user_id')
                           ->where("staff_companies.company_name LIKE ? OR staff_companies.company_address LIKE ?", "%{$searchString}%")
                           ->where("staff_companies.status != 'deleted' && staff_users.status != 'inactive'");                           
                    $results = $adapter->fetchAll($select);
                }
                elseif($category == 'employees')
                {
                    $searchString01 =$f->filter($this->_request->getPost('search_string_01'));

                    //empty input field if the value is default
                    if($searchString01 == 'First Name')
                    {
                        $searchString01 = '';
                    }
                    if($searchString == 'Last Name')
                    {
                        $searchString = '';
                    }

                    $adapter = Zend_Db_Table_Abstract::getDefaultAdapter();
                    $select = new Zend_Db_Select($adapter);
                    if(!empty($searchString01) && !empty($searchString))//if both first name and last name is filled
                    {   
                        $select->from('staff_employees', array('employee_id','first_name', 'middle_name', 'last_name', 'designation', 'created', 'photo'))
                               ->joinInner('staff_companies', 'staff_employees.user_id = staff_companies.user_id', array('company_name'))
                               ->where('staff_employees.first_name LIKE ?', "%{$searchString01}%")
                               ->where('staff_employees.last_name LIKE ?', "%{$searchString}%")
                               ->where("staff_employees.status != 'deleted' ");
                        $results = $adapter->fetchAll($select);
                    }
                    elseif(empty($searchString01))//if empty first name
                    {
                        
                        $select->from('staff_employees', array('employee_id','first_name', 'middle_name', 'last_name', 'designation', 'created', 'photo'))
                               ->joinInner('staff_companies', 'staff_employees.user_id = staff_companies.user_id', array('company_name'))
                                ->where('staff_employees.last_name LIKE ?', "%{$searchString}%")
                                ->where("staff_employees.status != 'deleted' ");
                        $results = $adapter->fetchAll($select);
                    }
                    else//find last name
                    {
                        $select->from('staff_employees', array('employee_id','first_name', 'middle_name', 'last_name', 'designation', 'created', 'photo'))
                               ->joinInner('staff_companies', 'staff_employees.user_id = staff_companies.user_id', array('company_name'))
                                ->where('staff_employees.first_name LIKE ?', "%{$searchString01}%")
                                ->where("staff_employees.status != 'deleted' ");
                        $results = $adapter->fetchAll($select);
                    }
                }
                else
                {
                    $this->_redirect('Index');
                }
        } 
        /* Code to display search datas */
        //sending category to view for dynamic result
        $this->view->category = $category;

        //for displaying the keyword
        $this->view->searchString01 = htmlentities($searchString01);
        $this->view->searchString = htmlentities($searchString);
        
        //sending number of results to view, and check if there is a value of results
        if($results != NULL) //do pagination and passing of the count
        {            
            if(is_array($results))
                $this->view->count = count($results);
            else
                $this->view->count = $results->count(); 
            // Zend paginator processs
            $page       = $this->_getParam('p', 1);
            $paginator  = Zend_Paginator::factory($results);

            //check if the category is copanies the result per page wil be 20 otherwise it will be 9
            /*
            if($category == 'companies')
            {
                $paginator->setItemCountPerPage(20);
            }
            else
            {
                $paginator->setItemCountPerPage(9);
            }
            */
            $paginator->setItemCountPerPage(15);
            
            $paginator->setCurrentPageNumber($page);
            //sending data to view
            $this->view->data = $paginator;

            //add cache to prevent back button for creating an error
            header("Cache-control: max-age=600");
        }   
        else // set the count to 0
        {
            $this->view->count = 0;
        }

        $auth = Zend_Auth::getInstance();
        if($auth->hasIdentity())
        {
            $this->view->login = 1;
        }
        else
        {
            $this->view->login = 0;
        }
    }


    /**
    *   Searched View function
    */
    public function searchViewAction()
    {
        
        // Page title
        $this->view->headTitle('Search View Results');
        
        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'search-view-page';

        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        $this->view->userId = $userId;
        
        //if not login, redirect to login page
        if(!isset(Zend_Auth::getInstance()->getIdentity()->user_id))
        {
            $this->_helper->flashMessenger->addMessage('<p class="msg error">You need to be login to access the page.</p>');
            $this->_redirect('pages/login');
        }

        //if login, but the user account is not yet activated, redirect to pending page
        if($this->sessionUser->status == 'inactive')
        {
            $this->_redirect('Index/pending');
        }

        //get parameter id value
        $id = $this->getRequest()->getParam('id');

        //if empty parameter, nothing happens
        if(empty($id))
        {
            $this->_redirect('/');
        }

        $this->view->id = $id;    
        $category = $this->getRequest()->getParam('category');
        $this->view->category = $category;

        $request = $this->getRequest();
        $result = $request->getHeader('referer');
        $array = explode("/", $result);
        $search = end($array);
        if($search == 'search')
        {
            $this->view->fromSearch = 1;
        }

        if($category == 'companies')
        {
            $companies = new Application_Model_Tables_Companies();
            $companiesRow = $companies->fetchRow($companies->select()->where("user_id = " . $id, 1)->where("status != 'deleted'"));
            $this->view->companiesRow = $companiesRow;

            $companiesCount = count($companiesRow);
            $this->view->count = $companiesCount;
            if($companiesCount > 0 )
            {
                $employees = new Application_Model_Tables_Employers();
                $employeesRow = $employees->fetchAll($employees->select()->where(" user_id = ".$id, 1)->where("status != 'deleted'"));

                $this->view->employeesCount = $employeesRow->count();
                //$this->view->employees_data = $employees_row;

                // Zend paginator processs
                $page       = $this->_getParam('p', 1);
                $paginator  = Zend_Paginator::factory($employeesRow);
                $paginator->setItemCountPerPage(5);
                $paginator->setCurrentPageNumber($page);
                //sending data to view
                $this->view->employeesData = $paginator;
            }

            //note: value of id is the parameter id (id of the viewed page company)
            //check if already connected
            $connection = new Application_Model_Tables_Connection();
            $row = $connection->fetchRow($connection->select()->where('connected_id = ?', $id)->where("status = 'not-deleted'")->where('account_id = ?', $userId));
            if(count($row) > 0 )
            {
                $this->view->connected = 1;
            }
            else
            {
                $this->view->connected = 0;
            }    
        }

        if($category == 'employees')
        {

            $employees = new Application_Model_Tables_Employers();
            $select = $employees->select();
            $select->where("employee_id = " . $id);
            $select->where("status != 'deleted'");
            $employeesRow = $employees->fetchRow($select);
            $this->view->employeesData = $employeesRow; 

            $employeesCount = count($employeesRow);
            $this->view->count = $employeesCount;
            if($employeesCount > 0 )
            {
                //get employers id to fetch the company name
                $employerId = $employeesRow['user_id'];
                

                $employer = new Application_Model_Tables_Companies();
                $this->view->employerData = $employer->fetchRow($employer->select()->where("user_id = " . $employerId, 1));
                //send to view the id for the link to the company
                $this->view->employerId = $employerId;
            } 
            
            //This is for the Mark type of the employee
            $mark = new Application_Model_Tables_Employeesmark();
            $row = $mark->fetchRow($mark->select()->where("user_id = ?", $userId)->where('employee_id =?', $id)->where('status = ?', 'not-deleted'));
            $this->view->row = $row;
            $this->view->marked = count($row);
            
        }
    }


    public function pendingAction()
    {
        // Page title
        $this->view->headTitle('Pending');
        
        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'pending-page';
    }



    public function confirmAction()
    {
        $link = $this->getRequest()->getParam('link');
        if(!empty($link))
        {
            $user = new Application_Model_Tables_Users();
            $result = $user->fetchRow($user->select()->where("link = ?", $link));
            if(count($result) > 0)
            {
                $username = $result->username;
                $password = $result->password;
                 // Get the default adapter  
                $dbAdapter      = Zend_Db_Table::getDefaultAdapter();
                // Get the prefix
                $dbTableName    = Zend_Registry::get('tablePrefix') . 'users';
                
                // Use advance authentication, with status = active
                $authAdapter    = new Zend_Auth_Adapter_DbTable($dbAdapter);
                
                $authAdapter->setTableName($dbTableName);
                $authAdapter->setIdentityColumn('username');
                $authAdapter->setCredentialColumn('password');
                // $authAdapter->set
                
                // Set the input credential values to authenticate against.
                $authAdapter->setIdentity($username);
                $authAdapter->setCredential($password);

                // Do the authentication.
                $auth   = Zend_Auth::getInstance();
                $result = $auth->authenticate($authAdapter);
                
                if ($result->isValid()) {
                    //if valid check if the status is inactive
                    $user = new Application_Model_Tables_Users();
                    $rows = $user->fetchRow($user->select()->where('username = ?', $username));  
                    // Success: store database row to auth's storage.
                    // System. (Not the password though!).
                    $data = $authAdapter->getResultRowObject(null, 'password');
                    // fetch object data from database
                    $user = $authAdapter->getResultRowObject();
                    $auth->getStorage()->write($data);

                    $authStorage = new Zend_Session_Namespace('authstorage');
                    $authStorage->member = $auth->getStorage()->read();

                    $this->_helper->flashMessenger->addMessage('<p class="msg done">Successfully log in.</p>');
                    $this->_redirect('employer');
                }
                else
                {
                    $this->_redirect('pages/login');
                }
            }
            else
            {
                $this->_redirect('pages/login');
            }

        }
        else
        {
            $this->_redirect('pages/login');

        }
    }
    

    /**
     * Twitter
     */
    public function twitterAction()
    {
        require_once(APPLICATION_PATH . '/../public/layout/twitteroauth/twitteroauth/twitteroauth.php'); //Path to twitteroauth library
     
        $search = "@PhStockExchange OR @ravelasj OR @Philbizwatcher OR @gus_cosio";
        $notweets = 6;
        $consumerkey = "au2KzrRjSdRCrLPiHKEOg";
        $consumersecret = "lTJoUJO1EUgBIoSd8C3FtrkbJLGPMyCymPBupnh0";
        $accesstoken = "1055745404-YG2pjQ5j0vydhnsewxGMxDkGuWQFb0lUOm9aTH0";
        $accesstokensecret = "OgJg6AlEThucMb66PpqC8M6yuvQuQENGgoPB0IGjaxTzb";
          
        function getConnectionWithAccessToken($cons_key, $cons_secret, $oauth_token, $oauth_token_secret) {
          $connection = new TwitterOAuth($cons_key, $cons_secret, $oauth_token, $oauth_token_secret);
          return $connection;
        }
        
        $connection = getConnectionWithAccessToken($consumerkey, $consumersecret, $accesstoken, $accesstokensecret);
         
        $search = str_replace("#", "%23", $search);
        // $tweets = $connection->get("https://api.twitter.com/1.1/search/tweets.json?q=".$search."&count=".$notweets);
        $tweets[] = $connection->get("https://api.twitter.com/1.1/statuses/user_timeline.json?screen_name=JobStreetPH&count=" . $notweets);
        $tweets[] = $connection->get("https://api.twitter.com/1.1/statuses/user_timeline.json?screen_name=jobsdbph&count=". $notweets);

        $data = array();
        foreach($tweets as $tweet)
        {
            foreach($tweet as $row)
            {
                $data[] = $row; // insert object to array
            }
        }
        echo json_encode($data); die();

        $this->_helper->layout->disableLayout(); // disable layout
    }
    

}