<?php

class PagesController extends Zend_Controller_Action
{
	
    
	/**
	 * Initialize action controller here.
	 */
    public function init()
    {
        // Set the flash messenger
		$this->view->flashMessenger = $this->_helper->flashMessenger->getMessages();

        $this->session = new Zend_Session_Namespace("mail");
    }

    
    /**
     * Index
     * @todo Temporarily redirect to registration. 
     */
    public function indexAction()
    {
        $this->_redirect('Index');
    }
    
    
    
    /**
    *   generate random string
    */
    public function randString()
    {
        $chars = "abcdefghijklmnopqrstuvwxyzABCEFGHIJKLMNOPQRSTUVWXYZ1234567890";
        $length = 15;
        $newPass = substr( str_shuffle( $chars ), 0, $length );

        return $newPass;
    }  
    
    
    
    /**
     * Company registration
     */
    public function companyRegistrationAction()
    {
        $this->view->headTitle('Company Registration');
        $this->view->bodyId = 'company-registration-page';

        if(isset(Zend_Auth::getInstance()->getIdentity()->user_id))
        {
            $this->_redirect('employer');
        }
        
        $url = $this->view->serverUrl() . $this->view->baseUrl();
        
        if($this->getRequest()->isPost())
        {
            $f = new Zend_Filter_StripTags();

            $companyName = $f->filter($this->_request->getPost('company_name'));
            $companyAddress = $f->filter($this->_request->getPost('company_address'));
            $zipcode = $f->filter($this->_request->getPost('zipcode'));
            $companyPhone = $f->filter($this->_request->getPost('company_phone'));
            $companyFax = $f->filter($this->_request->getPost('company_fax'));
            $companyEmail = $f->filter($this->_request->getPost('company_email'));
            $password1 = $f->filter($this->_request->getPost('password'));
            $password2 = $f->filter($this->_request->getPost('re_password'));
            $fname = $f->filter($this->_request->getPost('first_name'));
            $mname = $f->filter($this->_request->getPost('middle_name'));
            $lname = $f->filter($this->_request->getPost('last_name'));
            $designation = $f->filter($this->_request->getPost('designation'));
            $typeOfCompany = $f->filter($this->_request->getPost('type_of_company'));

            $formDatas = $this->getRequest()->getPost();
            $formDatas = $this->_helper->filterTags->filter($formDatas);
            $errors = $this->_helper->validateCompany->companyname($formDatas);
            if(empty($companyName) || empty($companyAddress) || empty($companyEmail) || empty($fname) || empty($mname) || empty($lname) || empty($designation) || empty($typeOfCompany) || empty($password1) || empty($password2) || empty($companyPhone) || empty($companyFax))
            {
                echo "<script type='text/javascript'>alert('One of the fields are empty.')</script>";
                $this->view->formDatas = $formDatas;
            }
            elseif(!ctype_digit($zipcode))
            {
                $this->view->flashMessenger[] = "<div class='msg error'>Zip Code field must be number only.</div>";
                $this->view->formDatas = $formDatas;
            }
            else
            {
                if($errors == null)
                {
                    if($formDatas['specify_company'])
                    {
                        $formDatas['type_of_company'] = $formDatas['specify_company'];
                    }
                
                    $users = new Application_Model_Tables_Users();
                    $company = new Application_Model_Tables_Companies();
                    $upload = new Zend_File_Transfer_Adapter_Http();
                    /* if IsImage validator is added, the file will not be uploaded because of the MIME error (mime can't be detected)
                    $upload->addValidator('IsImage', false)
                            ->addValidator('Size', false, 40000);

                    **** I think it is solved by the validator: ImageSize
                    */
                    $upload->addValidator('Size', false, 102400)
                           ->addValidator('Extension', false, array('jpg', 'jpeg', 'png'))
                           ->addValidator('ImageSize', false,
                                    array(
                                        'minwidth' => 100,
                                        'maxwidth' => 300,
                                        'minheight' => 100,
                                        'maxheight' => 300,
                                    )
                                );
                           
                    $photo = $upload->getFileName();
                    $uploadPath =  APPLICATION_PATH . "/../public/uploads/company_pic/";

                    if(!empty($photo))
                    {
                        if($upload->isValid())
                        {
                            $link = md5($companyEmail . date("Y-m-d H:i:s"));
                            $linkPath = $url . '/index/confirm/link/' . $link;
                            $formDatas['link'] = $link;
                            //fetch user_id and insert data to table staff_users
                            $userID = $users->insertUsers($formDatas);
                            // Store primary key at $formDatas array
                            $formDatas['user_id'] = $userID;
                            
                            //$photoName is equal to the name of the photo
                            if($photoName = $company->addCompany($formDatas, $photo))
                            {
                                //get the name, convert it to array and remove the last element of the array
                                $tmpName = array_slice(explode(".", $photoName), 0, -1);
                                //implode the array which result to the name of the folder
                                $folderName = implode("", $tmpName);
                                //make the folder name (base on the id of the user)
                                $createFolder = mkdir("{$uploadPath}{$folderName}", 0777);
                                //set upload destination
                                $upload->setDestination("{$uploadPath}{$folderName}/");

                                
                                
                                $whitelist = array('localhost', '127.0.0.1');
                                if(!in_array($_SERVER['HTTP_HOST'], $whitelist)){
                                    $this->_helper->responseEmail->registrationEmail($companyName, $linkPath, $companyEmail);
                                    $this->_helper->responseEmail->sendAlertEmail($formDatas);
                                }
                                
                                //renaming the photo uploaded
                                $upload->addFilter('Rename', $photoName);
                                $upload->receive();
                                
                                
                                // Get the file info i.e. tmp name, file name etc    
                                $filenames = $upload->getFileInfo();

                                // Get the first uploaded file info   
                                if (trim($filenames['uploadedfile']['name']) != null) 
                                {

                                    // The first image file
                                    $imageFilename  = $filenames['uploadedfile']['name'];

                                    // Save to formDatas
                                    $formDatas['uploadedfile'] = $imageFilename;

                                    // Create thumbnail name
                                    $imageThumbFilename = 'thumb_' . $photoName;

                                    // Save to formDatas
                                    $formDatas['image_thumb_filename'] = $imageThumbFilename;


                                    // Crop the image
                                    $this->_helper
                                         ->Crop
                                         ->imageCrop(100, 80, "$uploadPath/$folderName/$imageFilename", "$uploadPath/$folderName/$imageThumbFilename");
                                }

                                //$_SESSION['user_id'] = $userID;
                                $this->_helper->flashMessenger->addMessage('<p class="msg done">User successfully added. Please Log in to begin.</p>');

                                //session for email and link
                                $this->session->email = $companyEmail;
                                $this->session->linkPath = $linkPath;
                                $this->session->companyName = $companyName;
                                

                                //redirect user to log in
                                $this->_redirect('pages/registered');                                                                
                            }
                        }
                        else
                        {
                            $this->view->flashMessenger[] = "<div class='msg error'>Either the file is not an image, it exceeds the maximum upload size or maximum image dimension.</div>";
                            $this->view->formDatas = $formDatas;
                        }
                    
                    }
                    else
                    {
                        $link = md5($companyEmail . date("Y-m-d H:i:s"));
                        $linkPath = $url . '/index/confirm/link/' . $link;
                        $formDatas['link'] = $link;
                        $userID = $users->insertUsers($formDatas);
                        $formDatas['user_id'] = $userID;
                        $folderName = $company->addCompany($formDatas, $photo);
                        $createFolder = mkdir("{$uploadPath}{$folderName}", 0777);

                        $whitelist = array('localhost', '127.0.0.1');
                        if(!in_array($_SERVER['HTTP_HOST'], $whitelist)){
                            $this->_helper->responseEmail->registrationEmail($companyName, $linkPath, $companyEmail);
                            $this->_helper->responseEmail->sendAlertEmail($formDatas);
                        }
                        
                        $this->_helper->flashMessenger->addMessage('<p class="msg done">User successfully added. Please Log in to begin.</p>');

                        $this->session->email = $companyEmail;
                        $this->session->linkPath = $linkPath;
                        $this->session->companyName = $companyName;
//                        $this->session->password = $password1;
                        $this->_redirect('pages/registered');
                    }   
                }
                else
                {
                    $message = '<ul>';
                    foreach($errors as $error) {
                        $message.= "<li style='list-style-type: none;'><p class='msg error'>" . $error . "</p></li>";
                    }
                    $message.= '</ul>';                    
                    $this->view->flashMessenger[] = '<div>' . $message . '</div>'; 

                    $this->view->formDatas = $formDatas;
                }                
            }
        }
        
    }
    
    
    /**
     * View Login
     */
    public function loginAction()
    {
        $this->view->headTitle('Employer Login');
        $this->view->bodyId = 'company-registration-page';
        if(isset(Zend_Auth::getInstance()->getIdentity()->user_id))
        {
            $this->_redirect('employer');
        }

        if(isset($_COOKIE['rememberUsername']))
        {
            $user = new Application_Model_Tables_Users();
            $password = $user->fetchRow($user->select()->where('username = ?', $_COOKIE['rememberUsername']));
            $row = $password['password_human'];
            $this->view->password = $row;
        }
    }


    /**
     * View Pending Page
     */
    public function pendingAction()
    {
        $this->view->headTitle('Pending Login')    ;
        $this->view->bodyId = 'pending-login-page';
    }


    /**
     * Logout Function
     */
    public function logoutAction()
    {
        $authSession = new Zend_Session_Namespace('authstorage');
        unset($authSession->member);
        Zend_Auth::getInstance()->clearIdentity();
        $this->_redirect('pages/login');
    }


    /**
     * Member Companies Page
     */
    public function memberCompaniesAction()
    {
        $this->view->headTitle('Member Companies');        
        $this->view->bodyId = 'company-member-page';
        
        $companies = new Application_Model_Tables_Companies();
        $results = $companies->fetchActiveCompanies();
        $this->view->num_rows = $results->count();
        $page       = $this->_getParam('p', 1);
        $paginator  = Zend_Paginator::factory($results);
        $paginator->setItemCountPerPage(10);
        $paginator->setCurrentPageNumber($page);
        $this->view->rows = $paginator;

        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        $this->view->userId = $userId;
    }

    
    /**
     * About Us Page
     */
    public function aboutUsAction()
    {
        $this->view->headTitle('About Us');
        $this->view->bodyId = 'about-us-page';
    }


    /**
     *  How it Works Page
     */
    public function howItWorksAction()
    {
        $this->view->headTitle('How it works');
        $this->view->bodyId = 'how-it-works-page';    
    }


    /**
     *  Frequently Asked Questions Page
     */
    public function faqsAction()
    {
        $this->view->headTitle('Frequently Asked Questions');
        $this->view->bodyId = 'faqs-page';

        if($this->getRequest()->isPost())
        {
            $formDatas = $this->getRequest()->getPost();
            $formDatas = $this->_helper->filterTags->filter($formDatas);
            $email = $formDatas['email'];

            $errors = array();
            if($this->_request->getPost('secure') != $_SESSION['security_number'])
            {
                $errors['captcha'] = "Invalid Captcha.";
            }
            $validator = new Zend_Validate_EmailAddress();
            if (!$validator->isValid($email)) {     
                $errors['email'] = 'Email address is invalid ';
            }


            if($errors == NULL)
            {
                $this->_helper->ResponseEmail->faqsMail($formDatas);
                
                $this->_helper->flashMessenger->addMessage("<div class='msg done'>Message succesfully sent. </div>");
                $this->_redirect('pages/faqs');
            }
            else
            {
                $message = '<ul>';
                foreach($errors as $error) {
                    $message.= '<li>' . $error . '</li>';
                }
                $message.= '</ul>';
                $this->view->flashMessenger[] = '<div class="msg error">' . $message . '</div>';  
                $this->view->formDatas = $formDatas;
            }
        }
    }

    public function supportAction()
    {
        $this->view->headTitle('Support');
        $this->view->bodyId = 'support-page';

        if($this->getRequest()->getPost())
        {
            
            $formDatas = $this->getRequest()->getPost();
            $formDatas = $this->_helper->filterTags->filter($formDatas);
            $email = $formDatas['email'];

            $errors = array();
            if($this->_request->getPost('secure') != $_SESSION['security_number'])
            {
                $errors['captcha'] = "Invalid Captcha.";
            }
            $validator = new Zend_Validate_EmailAddress();
            if (!$validator->isValid($email)) {
                $errors['email'] = 'Email address is invalid ';
            }
            

            if($errors == NULL)
            {
                $upload = new Zend_File_Transfer_Adapter_Http();
                $upload->addValidator('Size', false, 102400);
                $name = $upload->getFileName();
                
                if(!empty($name))
                {
                    if($upload->isValid())
                    {
                        //file name is sender and date
                        $date = date("Y-m-d_H:i:s");
                        $uploadPath = APPLICATION_PATH . "/../public/uploads/supports";
                        
                        //Rename Image
                        $file = $upload->getFileInfo();
                        $fileInfo = pathinfo($upload->getFileName($file['uploadedfile']['name']));
                        $photoName = $email. "(" . $date . ")." .$fileInfo['extension'];
                        $upload->addFilter('Rename', array(
                        'target' => $uploadPath . '/' . $photoName,
                        'overwrite' => true));

                        //Receive the file
                        $upload->receive();
                        
                        $this->_helper->ResponseEmail->supportMail($formDatas, $photoName);
                        
                        $this->_helper->flashMessenger->addMessage("<div class='msg done'>Message succesfully sent. </div>");
                        
                        $this->_redirect('pages/support');
                    }
                    else
                    {
                        $this->view->flashMessenger[] = "<div class='msg error'>The file your trying to upload reach the maximum size. Please try again. Thank you.</div>";
                    }
                }
                else
                {

                    $this->_helper->ResponseEmail->supportMail($formDatas, null);
                    
                    $this->_helper->flashMessenger->addMessage("<div class='msg done'>Message succesfully sent. </div>");
                    
                    $this->_redirect('pages/support');
                }
            }
            else
            {
                $message = '<ul>';
                foreach($errors as $error) {
                    $message.= '<li>' . $error . '</li>';
                }
                $message.= '</ul>';
                $this->view->flashMessenger[] = '<div class="msg error">' . $message . '</div>';  
                $this->view->formDatas = $formDatas;
            }
        }
    }


    /**
     * Testimonials Page
     */
    public function testimonialsAction()
    {
        $this->view->headTitle('Testimonials');
        $this->view->bodyId = 'testimonials-page';

        if($this->getRequest()->getPost())
        {
            $name = $this->_request->getPost('name');
            $email = $this->_request->getPost('email');
            $companyName = $this->_request->getPost('company_name');
            $companyAddress = $this->_request->getPost('company_address');
            $contactNo = $this->_request->getPost('contact_no');
            $learned = $this->_request->getPost('learned');
            $message = $this->_request->getPost('message');

            $formDatas = $this->getRequest()->getPost();

            $errors = $this->_helper->contact->contactForm($formDatas);
            $errors = array();
            if($this->_request->getPost('secure') != $_SESSION['security_number'])
            {
                $errors['captcha'] = "Invalid Captcha.";
            }       

            if(empty($name) || empty($email) || empty($companyName) || empty($companyAddress) || empty($contactNo) || empty($learned) )
            {   
                $this->view->flashMessenger[] = "<div class='msg error'>One of the fields are empty.</div>";
            }
            else
            {
                if($errors == null)
                {
                    $testimonial = new Application_Model_Tables_Testimonials();                
                    $testimonial->addTestimony($formDatas);
                    $this->_helper->flashMessenger->addMessage('<p class="msg done">Testimonial successfully sent.  Thank you!</p>');
                    $this->_redirect('pages/testimonials');
                }
                else
                {
                    $message = '<ul>';
                    foreach($errors as $error) {
                        $message.= '<li>' . $error . '</li>';
                    }
                    $message.= '</ul>';
                    // $this->_helper->flashMessenger->addMessage('<div class="msg error">' . $message . '</div>');
                    $this->view->flashMessenger[] = '<div class="msg error">' . $message . '</div>';  
                    $this->view->formDatas = $formDatas;
                }
            }
        }
    }


    /**
     * Recover Password Page and function
     */
    public function recoveryAction()
    {
        $this->view->headTitle('Recovery');
        $this->view->bodyId = 'recovery-page';

        if($this->getRequest()->isPost())
        {
            $formDatas = $this->getRequest()->getPost();
            $formDatas = $this->_helper->filterTags->filter($formDatas);
            $email = $formDatas['email'];

            $errors = array();
            if($this->_request->getPost('secure') != $_SESSION['security_number'])
            {
                $errors['captcha'] = "Invalid Captcha.";
            }
            $validator = new Zend_Validate_EmailAddress();
            if (!$validator->isValid($email)) {     
                $errors['email'] = 'Email address is invalid ';
            }
            $validator = new Zend_Validate_Db_NoRecordExists(array('table' => Zend_Registry::get('tablePrefix') . 'users', 'field' => 'username'));
            if ($validator->isValid($email)) {
                $errors['username'] = "E-mail address doesn't exist, please try again.";
            }
            
            if($errors == null)
            {
                $user = new Application_Model_Tables_Users();
                $result = $user->fetchRow($user->select()->where("username = ?", $email)->where("deleted != 'no'"));
                if(count($result) > 0)
                {
                    $this->_helper
                    ->flashMessenger
                    ->addMessage('<p class="msg error">The details you have entered is incorrect.</a></p>');
                    $this->_redirect('pages/recovery');   
                }
                $newPass = $this->randString();            
                
                $password = $user->recoverPassword($formDatas, $newPass);

                $this->_helper->ResponseEmail->recoveryMail($formDatas, $newPass);
                $this->_helper->flashMessenger->addMessage('<p class="msg done">Password succesfully change.  Please check your E-mail.</p>');
                
                $this->_redirect('pages/recovery');
            }
            else
            {
                $message = '<ul>';
                foreach($errors as $error) {
                    $message.= '<li>' . $error . '</li>';
                }
                $message.= '</ul>';
                $this->view->flashMessenger[] = '<div class="msg error">' . $message . '</div>';  
                $this->view->formDatas = $formDatas;
            }
        }
    }



    /*
    ** Privacy Policy Page
    */
    public function privacyPolicyAction()
    {
        $this->view->headTitle('Privacy Policy');
        $this->view->bodyId = 'privacy-policy-page';


    }


    /*
    ** Terms of Use Page
    */
    public function termsOfUseAction()
    {
        $this->view->headTitle('Terms of Use');
        $this->view->bodyId = 'terms-of-use-page';

        
    }


    /*
    ** Disclaimer Page
    */
    public function disclaimerAction()
    {
        $this->view->headTitle('Disclaimer');
        $this->view->bodyId = 'disclaimer-page';

        
    }


    /*
    ** Registered Page
    */
    public function registeredAction()
    {
        $this->view->headTitle('Succesfully Registered');
        $this->view->bodyId = 'registered-page';

        $email = $this->session->email;
        $this->view->email = $email;
        if(empty($email))
        {
            $this->_redirect('Index');
        }
    }


    /*
    ** Resend Page
    */
    public function resendAction()
    {
        $this->request = $this->getRequest();
        $companyEmail = $this->request->getParam('email');
        $linkPath = $this->session->linkPath;
        $companyName = $this->session->companyName;
//      $password1 = $this->session->password;


        if(empty($companyEmail))
        {
            $this->_redirect('Index');
        }
        
        $html = new Zend_View();
        $html->setScriptPath(APPLICATION_PATH . '/views/scripts/email-template/');
        $html->assign(array('companyName' => $companyName, 
                            'linkPath' => $linkPath,
                     ));

        $msgbody = $html->render('registration-email.phtml');
        
        //send email notification
        $mail = new Zend_Mail();
        $mail->setReplyTo('support@staffchecking.com', 'Company')
            ->addHeader('MIME-Version', '1.0')
            ->addHeader('Content-Transfer-Encoding', '8bit')
            ->addHeader('X-Mailer:', 'PHP/'.phpversion())
            ->setBodyHtml($msgbody)
            ->setFrom('support@staffchecking.com', 'StaffChecking.com')
            ->addTo($companyEmail, 'StaffChecking.com New Client')
            ->setSubject('StaffChecking Account');
        
        //check if email was sent
        try
        {
            $mail->send();
        }
        catch(Zend_Mail_Transport_Exception $e)
        {
             $result ='error';
        }
        //if email is not sent return to registered else destroy the session email
        if($result == 'error')
        {
            $this->_redirect('pages/registered');
        }
        else
        {
            unset($this->session->email);   
        }
    }
    
    
    public function employeesAction(){
        $this->view->headTitle('Employees');
        
        $adapter = Zend_Db_Table_Abstract::getDefaultAdapter();
        $select = new Zend_Db_Select($adapter);
        $select->from('staff_employees', array('employee_id','first_name', 'middle_name', 'last_name', 'designation', 'created', 'photo'))
                               ->joinInner('staff_companies', 'staff_employees.user_id = staff_companies.user_id', array('company_name'))
                               ->where("staff_employees.status != 'deleted' ");
        $results = $adapter->fetchAll($select);
        
        
        //sending number of results to view, and check if there is a value of results
        if($results != NULL) //do pagination and passing of the count
        {            
            if(is_array($results))
                $this->view->count = count($results);
            else
                $this->view->count = $results->count(); 
            // Zend paginator processs
            $page       = $this->_getParam('p', 1);
            $paginator  = Zend_Paginator::factory($results);

            //check if the category is copanies the result per page wil be 20 otherwise it will be 9
            /*
            if($category == 'companies')
            {
                $paginator->setItemCountPerPage(20);
            }
            else
            {
                $paginator->setItemCountPerPage(9);
            }
            */
            $paginator->setItemCountPerPage(15);
            
            $paginator->setCurrentPageNumber($page);
            //sending data to view
            $this->view->data = $paginator;

            //add cache to prevent back button for creating an error
            header("Cache-control: max-age=600");
        }   
        else // set the count to 0
        {
            $this->view->count = 0;
        }
        
        $auth = Zend_Auth::getInstance();
        if($auth->hasIdentity())
        {
            $this->view->login = 1;
        }
        else
        {
            $this->view->login = 0;
        }
        
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        $this->view->userId = $userId;
        
    }


    /**
     * Ads
     */
    public function adWithUsAction()
    {
        if($this->getRequest()->getPost())
        {
            $formData = $this->getRequest()->getPost();
            // $errors = $this->_helper->contact->contactForm($formDatas);
            $errors = array();
            if($formData['secure'] != $_SESSION['security_number'])
            {
                $errors['captcha'] = "Invalid Captcha.";
            }       

            if(empty($formData['name']) || empty($formData['company_name']) || empty($formData['address']) || empty($formData['zip']) || empty($formData['telephone']) || empty($formData['message']) )
            {   
                $this->view->flashMessenger[] = "<div class='msg error'>One of the fields are empty.</div>";
            }
            else
            {
                $sendAdvertisement = $this->_helper->responseEmail->sendAdvertisement($formData);
                if($sendAdvertisement)
                {
                    $this->_helper->flashMessenger->addMessage('<p class="msg done">Message successfully sent.  Thank you!</p>');
                    $this->_redirect('pages/ad-with-us');
                }
            }
        }
    }
    
}