<?php

class SettingsController extends Zend_Controller_Action
{
	
	/**
	 * Before dispatching, check the security in general
 	 */
	public function preDispatch() 
	{
		$this->view->auth = Zend_Auth::getInstance();
		if (!$this->view->auth->hasIdentity()) { 
			$this->_helper->flashMessenger->addMessage('<p class="msg error">Error accessing the resquested page.</p>');
			$this->_redirect('/');
		}
	}
	
	
	/**
	 * Initialize action controller here
	 */
    public function init()
    {
    	// Set the flash messenger	
		$this->view->flashMessenger = $this->_helper->flashMessenger->getMessages();
	}
    
    
    
	/**
	 * List of settings
	 */
	public function indexAction()
    {
    	$this->view->headTitle('Settings');
        
   		// action body
		$settings = new Application_Model_Tables_Settings();
        
		if ($this->getRequest()->isPost()) {
			$formDatas = $this->getRequest()->getPost();
			foreach ($formDatas as $key => $data) {
				$datas = array('value' => $data);
				$settings->update($datas, 'setting_id = ' . (int)$key);
			}
            
            $this->_helper->flashMessenger->addMessage('<p class="msg done">Settings updated.</p>');
			$this->_redirect('settings');
		}
        
		// Get the results
		$this->view->settings = $settings->fetchAll(null, 'weight ASC');
	}
}

