<?php

class PagesController extends Zend_Controller_Action
{
	
    
	/**
	 * Initialize action controller here.
	 */
    public function init()
    {
        // Set the flash messenger
		$this->view->flashMessenger = $this->_helper->flashMessenger->getMessages();

        $this->session = new Zend_Session_Namespace("mail");
    }

    
    /**
     * Index
     * @todo Temporarily redirect to registration. 
     */
    public function indexAction()
    {
        $this->_redirect('index');
    }



    /**
    *   generate random string
    */
    public function randString()
    {
        $chars = "abcdefghijklmnopqrstuvwxyzABCEFGHIJKLMNOPQRSTUVWXYZ1234567890";
        $length = 15;
        $new_pass = substr( str_shuffle( $chars ), 0, $length );

        return $new_pass;
    }  
    
    
    
    /**
     * Company registration
     */
    public function companyRegistrationAction()
    {
        
        // Page title.
        $this->view->headTitle('Company Registration');
        
        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'company-registration-page';

        if(isset(Zend_Auth::getInstance()->getIdentity()->user_id))
        {
            $this->_redirect('employer');
        }

        if($this->getRequest()->isPost())
        {
            $f = new Zend_Filter_StripTags();

            $company_name = $f->filter($this->_request->getPost('company_name'));
            $company_address = $f->filter($this->_request->getPost('company_address'));
            $company_phone = $f->filter($this->_request->getPost('company_phone'));
            $company_fax = $f->filter($this->_request->getPost('company_fax'));
            $company_email = $f->filter($this->_request->getPost('company_email'));
            $password1 = $f->filter($this->_request->getPost('password'));
            $password2 = $f->filter($this->_request->getPost('re_password'));
            $fname = $f->filter($this->_request->getPost('first_name'));
            $mname = $f->filter($this->_request->getPost('middle_name'));
            $lname = $f->filter($this->_request->getPost('last_name'));
            $designation = $f->filter($this->_request->getPost('designation'));
            $type_of_company = $f->filter($this->_request->getPost('type_of_company'));

            $formDatas = $this->getRequest()->getPost();
            //validates username and password
            $errors = $this->_helper->validates->credentials($formDatas);
            $errors = $this->_helper->validateCompany->companyname($formDatas);
            if(empty($company_name) || empty($company_address) || empty($company_email) || empty($fname) || empty($mname) || empty($lname) || empty($designation) || empty($type_of_company) || empty($password1) || empty($password2) || empty($company_phone) || empty($company_fax))
            {
                echo "<script type='text/javascript'>alert('One of the fields are empty.')</script>";
                $this->view->formDatas = $formDatas;
            }
            else
            {
                if($errors == null)
                {
                
                    $users = new Application_Model_Tables_Users();

                    $company = new Application_Model_Tables_Companies();

                    //Uploading of Company Picture
                    $upload = new Zend_File_Transfer_Adapter_Http();
                    /* if IsImage validator is added, the file will not be uploaded because of the MIME error (mime can't be detected)
                    $upload->addValidator('IsImage', false)
                            ->addValidator('Size', false, 40000);

                    **** I think it is solved by the validator: ImageSize
                    */
                    $upload->addValidator('Size', false, 102400)
                           ->addValidator('ImageSize', false,
                                    array(
                                        'minwidth' => 200,
                                        'maxwidth' => 300,
                                        'minheight' => 200,
                                        'maxheight' => 300,
                                    )
                                );
                           
                    $photo = $upload->getFileName();
                                              
                    $uploadPath = "/home/puvprime/public_html/rad05/public/uploads/company_pic";

                    if(!empty($photo))
                    {
                        if($upload->isValid())
                        {
                            $link = md5($company_email . date("Y-m-d_H:i:s"));
                            $link_path = "http://pub.primeoutsourcing.com/rad05/index/confirm/link/" . $link;
                            $formDatas['link'] = $link;
                            //fetch user_id and insert data to table staff_users
                            $userID = $users->insertUsers($formDatas);
                            // Store primary key at $formDatas array
                            $formDatas['user_id'] = $userID;

                            //$photoName is equal to the name of the photo
                            if($photoName = $company->addCompany($formDatas, $photo))
                            {
                                //get the name, convert it to array and remove the last element of the array
                                $tmpName = array_slice(explode(".", $photoName), 0, -1);
                                //implode the array which result to the name of the folder
                                $folderName = implode("", $tmpName);
                                //make the folder name (base on the id of the user)
                                $createFolder = mkdir("{$uploadPath}/{$folderName}");
                                //set upload destination
                                $upload->setDestination("{$uploadPath}/{$folderName}");
                                $msgbody ="
                                        <html>                                            
                                        <body style='width: 100%; background: #ededed; padding: 20px 0 25px 0;'>
                                            <div id='wrapper' style='width: 600px; margin: 0 auto; background: #fff; padding: 1px 20px 20px 20px;'>
                                                <h1 style='text-decoration: none;'>$company_email</h1><br />
                                                <div style='float: left; '>
                                                <span>
                                                    You recently signed up for StaffChecking.ph. To complete<br />
                                                    signup, <b>click this button:</b>
                                                </span>
                                                </div>
                                                <div style='background: #fcac00; width: 150px; float: right; padding: 10px; border: 1px solid #db7500; border-radius:5px; -moz-border-radius: 5px; -webkit-border-radius: 5px;'>
                                                    <a href='{$link_path}' style='color: #fff; text-decoration: none; font-size: 16px; font-weight: bold;'>Click here to Log in</a>
                                                </div>
                                                <div style='clear: both;'></div>
                                                <hr style='margin: 10px 0;' />
                                                Or, you can copy and paste this link into your browser: <br />
                                                {$link_path} <br /><br />
                                                Thank you, <br />
                                                StaffChecking.ph Team
                                            </div>
                                        </body>                                
                                        </html>
                                        ";
                                //send email notification
                                $mail = new Zend_Mail();
                                $mail->setReplyTo('admin@staff-checking.com', 'Company')
                                    ->addHeader('MIME-Version', '1.0')
                                    ->addHeader('Content-Transfer-Encoding', '8bit')
                                    ->addHeader('X-Mailer:', 'PHP/'.phpversion())
                                    ->setBodyHtml($msgbody)
                                    ->setFrom('admin@staff-checking.com', 'StaffChecking.ph')
                                    ->addTo($company_email, 'Some Recipient')
                                    ->setSubject('Staff Checking Account')
                                    ->send();

                                //renaming the photo uploaded
                                $upload->addFilter('Rename', $photoName);
                                $upload->receive();

                                //$_SESSION['user_id'] = $userID;
                                $this->_helper->flashMessenger->addMessage('<p class="msg done">User successfully added. Please Log in to begin.</p>');

                                //session for email and link
                                $this->session->email = $company_email;
                                $this->session->link_path = $link_path;

                                //redirect user to log in
                                $this->_redirect('pages/registered');                                                                
                            }
                        }
                        else
                        {
                            $this->view->flashMessenger[] = "<div class='msg error'>Either the file is not an image, it exceeds the maximum upload size or maximum image dimension.</div>";
                            $this->view->formDatas = $formDatas;
                        }
                    
                    }
                    else
                    {
                        $link = md5($company_email . date("Y-m-d_H:i:s"));
                        $link_path = "http://pub.primeoutsourcing.com/rad05/index/confirm/link/" . $link;
                        $formDatas['link'] = $link;
						//fetch user_id and insert data to table staff_users
                        $userID = $users->insertUsers($formDatas);
                        // Store primary key at $formDatas array
                        $formDatas['user_id'] = $userID;
                        //if photo is empty, receive id
                        $folderName = $company->addCompany($formDatas, $photo);
                        //create folder base on id, but store default.jpg on database
                        $createFolder = mkdir("{$uploadPath}/$folderName");
                        //send email notification
                        
                        $msgbody ="
                                <html>                                            
                                <body style='width: 100%; background: #ededed; padding: 20px 0 25px 0;'>
                                    <div id='wrapper' style='width: 600px; margin: 0 auto; background: #fff; padding: 1px 20px 20px 20px;'>
                                        <h1 style='text-decoration: none;'>$company_email</h1><br />
                                        <div style='float: left; '>
                                        <span>
                                            You recently signed up for StaffChecking.ph. To complete<br />
                                            signup, <b>click this button:</b>
                                        </span>
                                        </div>
                                        <div style='background: #fcac00; width: 150px; float: right; padding: 10px; border: 1px solid #db7500; border-radius:5px; -moz-border-radius: 5px; -webkit-border-radius: 5px;'>
                                            <a href='{$link_path}' style='color: #fff; text-decoration: none; font-size: 16px; font-weight: bold;'>Click here to Log in</a>
                                        </div>
                                        <div style='clear: both;'></div>
                                        <hr style='margin: 10px 0;' />
                                        Or, you can copy and paste this link into your browser: <br />
                                        {$link_path} <br /><br />
                                        Thank you, <br />
                                        StaffChecking.ph Team
                                    </div>
                                </body>                                
                                </html>
                                ";
                        $mail = new Zend_Mail();
                        $mail->setReplyTo('admin@staff-checking.com', 'Company')
                            ->addHeader('MIME-Version', '1.0')
                            ->addHeader('Content-Transfer-Encoding', '8bit')
                            ->addHeader('X-Mailer:', 'PHP/'.phpversion())
                            ->setBodyHtml($msgbody)
                            ->setFrom('admin@staff-checking.com', 'StaffChecking.ph')
                            ->addTo($company_email, 'Some Recipient')
                            ->setSubject('Staff Checking Account')
                            ->send();

                        $this->_helper->flashMessenger->addMessage('<p class="msg done">User successfully added. Please Log in to begin.</p>');

                        //session for email
                        $this->session->email = $company_email;
                        $this->session->link_path = $link_path;

                        $this->_redirect('pages/registered');
                    }   
                }
                else
                {
                    $message = '<ul>';
                    foreach($errors as $error) {
                        $message.= '<li><p class="msg error">' . $error . '</p></li>';
                    }
                    $message.= '</ul>';                    
                    $this->view->flashMessenger[] = '<div>' . $message . '</div>'; 

                    $this->view->formDatas = $formDatas;
                }                
            }
        }
        
    }
    
    
    /**
     * 
     */
    public function loginAction()
    {
        // Page title.
        $this->view->headTitle('Employer Login');
        
        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'company-registration-page';

        if(isset(Zend_Auth::getInstance()->getIdentity()->user_id))
        {
            $this->_redirect('employer');
        }
        
    }

    public function pendingAction()
    {
        //Page Title.
        $this->view->headTitle('Pending Login')    ;

        $this->view->bodyId = 'pending-login-page';
    }
    public function logoutAction()
    {
        $auth = Zend_Auth::getInstance();
        $auth->clearIdentity();
        session_start();
        session_destroy();

        $this->_redirect('pages/login');
    }

    public function memberCompaniesAction()
    {
        // Page title.
        $this->view->headTitle('Member Companies');
        
        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'company-member-page';
    }
    
    public function aboutUsAction()
    {
        // Page title.
        $this->view->headTitle('About Us');
        
        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'about-us-page';
    }

    public function howItWorksAction()
    {
        // Page title.
        $this->view->headTitle('How it works');
        
        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'how-it-works-page';    
    }


    public function faqsAction()
    {
        // Page title.
        $this->view->headTitle('Frequently Asked Questions');
        
        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'faqs-page';

        if($this->getRequest()->isPost())
        {
            $name = $this->_request->getPost('name');
            $company_name = $this->_request->getPost('company_name');
            $email = $this->_request->getPost('email');
            $message = $this->_request->getPost('message');

            $formDatas = $this->getRequest()->getPost();
            //echo "<pre>" . print_r($formDatas, true) . "</pre>"; die();
            if(empty($name) || empty($company_name) || empty($email) || empty($message))
            {
                $this->view->flashMessenger[] = "<div class='msg error'>Either one of the fields are empty. </div>";
                $this->view->formDatas = $formDatas;
            }
            else
            {
                $mail = new Zend_Mail();
                $mail->setBodyText($message)
                    ->setFrom($email, 'StaffChecking.ph')
                    ->addTo('jhunsanne@primeoutsourcing.com', 'StaffChecking.ph Admin')
                    ->setSubject('StaffChecking.ph - Questions and Concerns')
                    ->send();
            }
        }
    }

    public function supportAction()
    {
        // Page title.
        $this->view->headTitle('Support');
        
        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'support-page';

        if($this->getRequest()->getPost())
        {
            $name = $this->_request->getPost('name');
            $email = $this->_request->getPost('email');
            $message = $this->_request->getPost('message');

            $formDatas = $this->getRequest()->getPost();
            if(empty($name) || empty($email) || empty($message))
            {
                $this->view->flashMessenger[] = "<div class='msg error'>Either one of the fields are empty. </div>";
                $this->view->formDatas = $formDatas;
            }
            else
            {
                $upload = new Zend_File_Transfer_Adapter_Http();
                $upload->addValidator('Size', false, 102400);

                $name = $upload->getFileName();

                $uploadPath = "/home/puvprime/public_html/rad05/public/uploads/supports";
                if(!empty($name))
                {
                    if($upload->isValid())
                    {
                        //file name is sender and date
                        $extension = end(explode(".", $name));
                        $date = date("Y-m-d_H:i:s");
                        $uploadName = $email . "(" . $date . ")." . $extension;

                        $upload->setDestination($uploadPath);   
                        $upload->addFilter('Rename', $uploadName);

                        $msgBody = "
                                Support Message: <br />{$message} <br /><br />         
                                Name of the attachment: <br />
                                {$uploadName}
                                ";
                        $mail = new Zend_Mail();
                        $mail->setBodyHtml($msgBody)
                             ->setFrom($email, 'StaffChecking.ph Client')
                             ->addTo('jhunsanne@molavenet.com', 'StaffChecking.ph Admin')
                             ->setSubject('StaffChecking.ph - Support')
                             ->send();

                        //receive file
                        $upload->receive();
                        $this->view->flashMessenger[] = "<div class='msg done'>Message succesfully sent. </div>";
                    }
                    else
                    {
                        $this->view->flashMessenger[] = "<div class='msg error'>The file your trying to upload reach the maximum size. Please try again. Thank you.</div>";
                    }
                }
                else
                {
                    $msgBody = "
                            Support Message: <br />
                            {$message}
                            ";
                    $mail = new Zend_Mail();
                    $mail->setBodyHtml($msgBody)
                         ->setFrom($email, 'StaffChecking.ph Admin')
                         ->addTo('jhunsanne@molavenet.com', 'StaffChecking Client')
                         ->setSubject('StaffChecking.ph - Support')
                         ->send();
                    $this->view->flashMessenger[] = "<div class='msg done'>Message succesfully sent. </div>";                         
                }

            }
        }
    }

    public function testimonialsAction()
    {
        // Page title.
        $this->view->headTitle('Testimonials');
        
        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'testimonials-page';

        if($this->getRequest()->getPost())
        {
            $name = $this->_request->getPost('name');
            $email = $this->_request->getPost('email');
            $company_name = $this->_request->getPost('company_name');
            $company_address = $this->_request->getPost('company_address');
            $contact_no = $this->_request->getPost('contact_no');
            $learned = $this->_request->getPost('learned');
            $message = $this->_request->getPost('message');

            $formDatas = $this->getRequest()->getPost();

            $errors = $this->_helper->contact->contactForm($formDatas);

            if(empty($name) || empty($email) || empty($company_name) || empty($company_address) || empty($contact_no) || empty($learned) )
            {   
                $this->view->flashMessenger[] = "<div class='msg error'>One of the fields are empty.</div>";
            }
            else
            {
                if($errors == null)
                {
                    $testimonial = new Application_Model_Tables_Testimonials();                
                    $testimonial->addTestimony($formDatas);
                    $this->_helper->flashMessenger->addMessage('<p class="msg done">Testimonial successfully sent.  Thank you!</p>');
                    $this->_redirect('pages/testimonials');
                }
                else
                {
                    $message = '<ul>';
                    foreach($errors as $error) {
                        $message.= '<li>' . $error . '</li>';
                    }
                    $message.= '</ul>';
                    // $this->_helper->flashMessenger->addMessage('<div class="msg error">' . $message . '</div>');
                    $this->view->flashMessenger[] = '<div class="msg error">' . $message . '</div>';  
                    $this->view->formDatas = $formDatas;
                }
            }
        }
    }



    public function recoveryAction()
    {
        // Page title.
        $this->view->headTitle('Recovery');
        
        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'recovery-page';

        if($this->getRequest()->isPost())
        {
            $email = $this->_request->getPost('email');

            if(!empty($email))
            {
                $formDatas = $this->getRequest()->getPost();

                $errors = $this->_helper->validateEmail->recoveryEmail($formDatas);

                if($errors == null)
                {
                    //variable containing random string
                    $new_pass = $this->randString();
                    //passing of email and changing of password
                    $user = new Application_Model_Tables_Users();                
                    $password = $user->recoverPassword($formDatas, $new_pass);

                    //send password to recipient
                    $mail = new Zend_Mail();
                    $mail->setBodyText("This is your new password: {$new_pass}.  Please login and change your password. Thanks!")
                        ->setFrom('jhunsanne@primeoutsourcing.com', 'StaffChecking.ph')
                        ->addTo($formDatas['email'], 'Recepient')
                        ->setSubject('StaffChecking.ph Notification')
                        ->send();

                    $this->_helper->flashMessenger->addMessage('<p class="msg done">Password succesfully change.  Please check your E-mail.</p>');
                    $this->_redirect('pages/recovery');
                }
                else
                {
                    $message = '<ul>';
                    foreach($errors as $error) {
                        $message.= '<li>' . $error . '</li>';
                    }
                    $message.= '</ul>';
                    // $this->_helper->flashMessenger->addMessage('<div class="msg error">' . $message . '</div>');
                    $this->view->flashMessenger[] = '<div class="msg error">' . $message . '</div>';  
                    $this->view->formDatas = $formDatas;
                }
            }
            else
            {
                $this->_helper->flashMessenger->addMessage('<div class="msg error">One of the fields are empty</div>');
                $this->_redirect('pages/recovery');
            }
        }
    }



    /*
    ** Privacy Policy Page
    */
    public function privacyPolicyAction()
    {
        // Page title.
        $this->view->headTitle('Privacy Policy');
        
        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'privacy-policy-page';


    }


    /*
    ** Terms of Use Page
    */
    public function termsOfUseAction()
    {
        // Page title.
        $this->view->headTitle('Terms of Use');
        
        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'terms-of-use-page';

        
    }


    /*
    ** Disclaimer Page
    */
    public function disclaimerAction()
    {
        // Page title.
        $this->view->headTitle('Disclaimer');
        
        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'disclaimer-page';

        
    }


    /*
    ** Registered Page
    */
    public function registeredAction()
    {
        // Page title.
        $this->view->headTitle('Succesfully Registered');
        
        // Custom id of body.
        // @todo it will be removed in the future.
        $this->view->bodyId = 'registered-page';
        //store session with the value of the email
        $email = $this->session->email;
        //send email value to view
        $this->view->email = $email;

        if(empty($email))
        {
            $this->_redirect('index');
        }
      
    }


    /*
    ** Resend Page
    */
    public function resendAction()
    {
        $this->request = $this->getRequest();

        $email = $this->request->getParam('email');
        //session for link path
        $link_path = $this->session->link_path;

        if(empty($email))
        {
            $this->_redirect('index');
        }
        
        $msgbody ="
                <html>                                            
                <body style='width: 100%; background: #ededed; padding: 20px 0 25px 0;'>
                    <div id='wrapper' style='width: 600px; margin: 0 auto; background: #fff; padding: 1px 20px 20px 20px;'>
                        <h1 style='text-decoration: none;'>$company_email</h1><br />
                        <div style='float: left; '>
                        <span>
                            You recently signed up for StaffChecking.ph. To complete<br />
                            signup, <b>click this button:</b>
                        </span>
                        </div>
                        <div style='background: #fcac00; width: 150px; float: right; padding: 10px; border: 1px solid #db7500; border-radius:5px; -moz-border-radius: 5px; -webkit-border-radius: 5px;'>
                            <a href='{$link_path}' style='color: #fff; text-decoration: none; font-size: 16px; font-weight: bold;'>Click here to Log in</a>
                        </div>
                        <div style='clear: both;'></div>
                        <hr style='margin: 10px 0;' />
                        Or, you can copy and paste this link into your browser: <br />
                        {$link_path} <br /><br />
                        Thank you, <br />
                        StaffChecking.ph Team
                    </div>
                </body>                                
                </html>
                ";
        //send email notification
        $mail = new Zend_Mail();
        $mail->setReplyTo('admin@staff-checking.com', 'Company')
            ->addHeader('MIME-Version', '1.0')
            ->addHeader('Content-Transfer-Encoding', '8bit')
            ->addHeader('X-Mailer:', 'PHP/'.phpversion())
            ->setBodyHtml($msgbody)
            ->setFrom('admin@staff-checking.com', 'StaffChecking.ph')
            ->addTo($email, 'Some Recipient')
            ->setSubject('Staff Checking Account');
        
        //check if email was sent
        try
        {
            $mail->send();
        }
        catch(Zend_Mail_Transport_Exception $e)
        {
             $result ='error';
        }
        //if email is not sent return to registered else destroy the session email
        if($result == 'error')
        {
            $this->_redirect('pages/registered');
        }
        else
        {
            unset($this->session->email);   
        }

    }
    
       
}