<?php

class Zend_Controller_Action_Helper_Crop extends Zend_Controller_Action_Helper_Abstract  
{
    
    public function imageCrop($nw, $nh, $source, $dest, $processor="gd", $im_path="/usr/local/bin/convert", $filter="-filter Cubic -unsharp 1.0x1.0+0.5 -modulate 107,110 -enhance") 
    {
    
        // Get the images info
        $image  = getimagesize($source);
        
        // Check the $image if theres a value if not it is not image
        if ($image != null) {
            
            $w      = $image[0];
            $h      = $image[1];
            $stype  = $image[2];
        
            if ($processor == 'gd') {
                
                switch($stype) {
                    case '1':
                    $simg = @imagecreatefromgif($source);
                    break;
    
                    case '2':
                    $simg = @imagecreatefromjpeg($source);
                    break;
                
                    case '3':
                    $simg = @imagecreatefrompng($source);
                    break;
                }
                $dimg = @imagecreatetruecolor($nw, $nh);
            }
                $wm = $w/$nw;
                $hm = $h/$nh;
           
                $h_height = $nh/2;
                $w_height = $nw/2;
            
            if ($wm> $hm) {
                
                $adjusted_width = $w / $hm;
                $half_width     = $adjusted_width / 2;
                $int_width      = $half_width - $w_height;
                
                if ($processor == 'gd') {
                    @imagecopyresampled($dimg, $simg, -$int_width, 0, 0, 0, $adjusted_width, $nh, $w, $h);
                    @imagejpeg($dimg,$dest,100);
                    
                } elseif ($processor == 'imagemagick') {
                    system("$im_path $source -resize $adjusted_width"."x$nh -gravity center -crop $nw"."x$nh+0+0 +repage ".
                            "$filter -quality 90 $dest");       
                }
                
            } elseif($wm < $hm) {
                
                $adjusted_height = $h / $wm;
                $half_height = $adjusted_height / 2;
                $int_height = $half_height - $h_height;
                
                if ($processor == 'gd') {
                    @imagecopyresampled($dimg, $simg, 0, -$int_height, 0, 0, $nw, $adjusted_height, $w, $h);
                    @imagejpeg($dimg, $dest, 100);
                
                } elseif ($processor == 'imagemagick') {
                    system("$im_path $source -resize $nw"."x$adjusted_height -gravity center -crop $nw"."x$nh+0+0 +repage ".
                            "$filter -quality 90 $dest");
                }
                    
            } else {
                
                if ($processor == 'gd') {   
                    @imagecopyresampled($dimg, $simg, 0, 0, 0, 0, $nw, $nh, $w, $h);
                    @imagejpeg($dimg, $dest, 100);
                
                } elseif ($processor == 'imagemagick') {
                    $adjusted_height = $h / $wm;
                    system("$im_path $source -resize $nw"."x$nh -gravity center -crop $nw"."x$nh+0+0 +repage ".
                            "$filter -quality 90 $dest");
                }
            }
            return true;
            
            // Else return false
        } else {
            return false;
        }
    }	
}