<?php 
class Zend_Controller_Action_Helper_Recaptcha extends Zend_Controller_Action_Helper_Abstract 
{

	public function checkSupport($formDatas = array(), $recaptcha)
	{
		$errors = array();

		if(empty($formDatas['name']) || empty($formDatas['email']) || empty($formDatas['message']))
		{
			$errors['field'] = 'One of the fields is empty.';
		}

		$email = new Zend_Validate_EmailAddress();
		if(!empty($formDatas['email']) && !$email->isValid($formDatas['email']))
		{
			$errors['email'] = 'Invalid Email Format';
		}

		if(empty($formDatas['recaptcha_response_field']))
		{
			$errors['recaptcha'] = 'You entered an invalid captcha.';	
		}
		else
		{
			$results = $recaptcha->verify($formDatas['recaptcha_challenge_field'], $formDatas['recaptcha_response_field']);
			if(!$results->isValid())
			{
				$errors['recaptcha'] = 'You entered an invalid captcha.';	
				
			}
		}

		return $errors;
	}


	public function checkFaqs($formDatas = array(), $recaptcha)
	{
		$errors = array();

		if(empty($formDatas['name']) || empty($formDatas['company_name']) || empty($formDatas['email']) || empty($formDatas['message']))
		{
			$errors['field'] = 'One of the fields is empty';
		}

		$email = new Zend_Validate_EmailAddress();
		if(!empty($formDatas['email']) && !$email->isValid($formDatas['email']))
		{
			$errors['email'] = 'Invalid Email Format.';
		}

		if(empty($formDatas['recaptcha_response_field']))
		{
			$errors['recaptcha'] = 'You entered an invalid captcha.';	
		}
		else
		{
			$results = $recaptcha->verify($formDatas['recaptcha_challenge_field'], $formDatas['recaptcha_response_field']);
			if(!$results->isValid())
			{
				$errors['recaptcha'] = 'You entered an invalid captcha.';	
				
			}
		}

		return $errors;
	}


	public function checkRecovery($formDatas = array(), $recaptcha)
	{
		$errors = array();

		if(empty($formDatas['email']))
		{
			$errors['email'] = "Email field is empty.";
		}

		$validator = new Zend_Validate_EmailAddress();
		if(!empty($formDatas['email']) && !$validator->isValid($formDatas['email']))
		{
			$errors['email'] = 'Invalid Email Format.';
		}

		if(empty($formDatas['recaptcha_response_field']))
		{
			$errors['recaptcha'] = 'You entered an invalid captcha.';	
		}
		else
		{
			$results = $recaptcha->verify($formDatas['recaptcha_challenge_field'], $formDatas['recaptcha_response_field']);
			if(!$results->isValid())
			{
				$errors['recaptcha'] = 'You entered an invalid captcha.';	
				
			}
		}

		return $errors;
	}

}
?>