<?php 
class Zend_Controller_Action_Helper_ResponseEmail extends Zend_Controller_Action_Helper_Abstract 
{

	public function registrationEmail($companyName, $linkPath, $companyEmail)
    {
        //parameters:
        // ($companyName, $linkPath, $companyEmail, $password)
        // $msgbody ="
        //     <html>
        //     <body style='width: 100%; background: #ededed;>
        //         <div id='wrapper' style='width: 100%; margin: 0 auto; background: #fff; padding: 20px;'>
        //         Hi, $companyName! <br /><br /><br />


        //         Welcome to Staff Checking!<br /><br /><br />


        //         Thank you for signing up with us. You are now a member of our exclusive community. Here are your log in details:
        //         <ul>
        //             <li>Username: {$companyEmail}</li>
        //             <li style='margin-top: 10px;'>Password: {$password}</li>
        //         </ul>

        //         Please user your username and password every time you log in. You may access your account <a href='{$linkPath}'>here</a>.
        //         <br /><br /><br />

        //         With Staff Checking, screening of potential employees is now an easy task. You never have to worry about hiring untrustworthy people ever again.
        //         <ul>
        //             <li>Check our database to see if your applicant has a criminal record or has unpaid loans from previous employers</li>
        //             <li style='margin-top: 10px;'>Be informed of other details pertaining to new applicants such as employer assessment and amount of final salary received</li>
        //             <li style='margin-top: 10px;'>Share your own database with other members of the community</li>
        //         </ul><br />

        //         Additional Resources:<br />
        //         <ul>
        //             <li>Want to know more about Staff Checking? Please check out our About Page.</li>
        //             <li style='margin-top: 10px;'>Visit our Member Companies page to browse companies who have shared their own database with us</li>
        //             <li style='margin-top: 10px;'>Got questions? Go to our FAQ page to get some answers.</li>
        //         </ul><br /><br />

        //         Thanks,<br /><br />

        //         Staff Checking Team
                    
        //         </div>
        //     </body>                                
        //     </html>
        //     ";
//        $msgbody ="
//            <html>                                            
//            <body style='width: 100%; background: #ededed; padding: 20px 0 25px 0;'>
//                <div id='wrapper' style='width: 600px; margin: 0 auto; background: #fff; padding: 1px 20px 20px 20px;'>
//                    <h1 style='text-decoration: none;'>$companyName</h1><br />
//                    <div style='float: left; '>
//                    <span>
//                        You recently signed up for StaffChecking.ph. To complete<br />
//                        signup, <b>click this button:</b>
//                    </span>
//                    </div>
//                    <div style='background: #fcac00; width: 150px; float: right; padding: 10px; border: 1px solid #db7500; border-radius:5px; -moz-border-radius: 5px; -webkit-border-radius: 5px;'>
//                        <a href='{$linkPath}' style='color: #fff; text-decoration: none; font-size: 16px; font-weight: bold;'>Click here to Log in</a>
//                    </div>
//                    <div style='clear: both;'></div>
//                    <hr style='margin: 10px 0;' />
//                    Or, you can copy and paste this link into your browser: <br />
//                    {$linkPath} <br /><br />
//                    Thank you, <br />
//                    StaffChecking.com Team
//                </div>
//            </body>                                
//            </html>
//            ";
        
        $html = new Zend_View();
        $html->setScriptPath(APPLICATION_PATH . '/views/scripts/email-template/');
        $html->assign(array('companyName' => $companyName, 
                            'linkPath' => $linkPath,
                     ));

        $msgbody = $html->render('registration-email.phtml');

        //send email notification
        $mail = new Zend_Mail();
        $mail->setReplyTo('support@staffchecking.com', 'Company')
            ->addHeader('MIME-Version', '1.0')
            ->addHeader('Content-Transfer-Encoding', '8bit')
            ->addHeader('X-Mailer:', 'PHP/'.phpversion())
            ->setBodyHtml($msgbody)
            ->setFrom('support@staffchecking.com', 'StaffChecking.com')
            ->addTo($companyEmail, $companyName)
            ->setSubject('StaffChecking Account')
            ->send();

        return $mail;
    }


    /**
     * Email alert to support@staffchecking.com whenever new user sign-up
     * @param array $formdData
     * @return int
     */
    public function sendAlertEmail($formData = array())
    {
        $companyName = $formData['company_name'];
        $companyEmail = $formData['company_email'];
        $companyPhone = $formData['company_phone'];
        $fullName = $formData['first_name'] . ' ' . $formData['middle_name'] . ' ' . $formData['last_name'];
        
        $html = new Zend_View();
        $html->setScriptPath(APPLICATION_PATH . '/views/scripts/email-template/');
        $html->assign(array('fullName' => $fullName, 
                            'companyName' => $companyName,
                            'companyPhone' => $companyPhone,
                            'companyEmail' => $companyEmail,
                     ));

        $msgbody = $html->render('send-alert-email.phtml');
        
        $mail = new Zend_Mail();
        $mail->setReplyTo($companyEmail, 'StaffChecking')
            ->addHeader('MIME-Version', '1.0')
            ->addHeader('Content-Transfer-Encoding', '8bit')
            ->addHeader('X-Mailer:', 'PHP/'.phpversion())
            ->setBodyHtml($msgbody)
            ->setFrom($companyEmail, 'StaffChecking')
            ->addTo('support@staffchecking.com', 'StaffChecking Support')
            ->addTo('media@staffchecking.com', 'StaffChecking Support')
            ->setSubject('StaffChecking Alert! New user registered!');
        return $mail->send();
    }
    
    
    public function verificationAccount($formDatas, $account){
        $companyName = $formDatas['company_name'];
        $companyEmail = $formDatas['company_email'];
        $companyPhone = $formDatas['company_phone'];
        $fullName = $formDatas['first_name'] . ' ' . $formDatas['middle_name'] . ' ' . $formDatas['last_name'];
        
        if($account == 'BP'){
            $msgbody ="
            <html>                                            
            <body style='width: 100%; background: #ededed; padding: 20px 0 25px 0;'>
                <div id='wrapper' style='width: 600px; margin: 0 auto; background: #fff; padding: 1px 20px 20px 20px;'>
                    <h1 style='text-decoration: none;'>Good Day StaffChecking Support!</h1><br />
                    <div>
                    <span>
                        There's user that upload a Business Permit!<br />
                        Below are the informations:<br /><br />
                    </span>
                    </div>
                    <div>
                    <strong>Full Name:</strong> {$fullName} <br />
                    <strong>Company Name: </strong> {$companyName} <br />
                    <strong>Company Phone No.:</strong> {$companyPhone} <br />
                    <strong>Company Email:</strong> {$companyEmail}<br /><br />
                    </div>
                    <br/>
                    <a href='https://staffchecking.com/public/uploads/company_verification/{$formDatas['user_id']}/{$formDatas['business_permit']}'>Click here to see Business Permit!</a>
                    <br/><br/>
                    Thank you, <br />
                    StaffChecking.com Team
                </div>
            </body>                                
            </html>
            ";
                    
    
        $mail = new Zend_Mail();
        $mail->setReplyTo($companyEmail, $companyName)
            ->addHeader('MIME-Version', '1.0')
            ->addHeader('Content-Transfer-Encoding', '8bit')
            ->addHeader('X-Mailer:', 'PHP/'.phpversion())
            ->setBodyHtml($msgbody)
            ->setFrom($companyEmail, $companyName)
            ->addTo('support@staffchecking.com', 'StaffChecking Support')
            ->addTo('support@staffchecking.com', 'StaffChecking Support')
            ->setSubject('StaffChecking Alert! New Business Permit!');

        return $mail->send();
        
        }elseif($account == 'LOA'){
            $msgbody ="
            <html>                                            
            <body style='width: 100%; background: #ededed; padding: 20px 0 25px 0;'>
                <div id='wrapper' style='width: 600px; margin: 0 auto; background: #fff; padding: 1px 20px 20px 20px;'>
                    <h1 style='text-decoration: none;'>Good Day StaffChecking Support!</h1><br />
                    <div>
                    <span>
                        There's user that upload a Letter of Authorization!<br />
                        Below are the informations:<br /><br />
                    </span>
                    </div>
                    <div>
                    <strong>Full Name:</strong> {$fullName} <br />
                    <strong>Company Name: </strong> {$companyName} <br />
                    <strong>Company Phone No.:</strong> {$companyPhone} <br />
                    <strong>Company Email:</strong> {$companyEmail}<br /><br />
                    </div>
                    <br/>
                    <a href='https://staffchecking.com/public/uploads/company_verification/{$formDatas['user_id']}/{$formDatas['letter_of_authorization']}'>Click here to see Letter of Authorization!</a>
                    <br/><br/>
                    Thank you, <br />
                    StaffChecking.com Team
                </div>
            </body>                                
            </html>
            ";
        
        $mail = new Zend_Mail();
        $mail->setReplyTo($companyEmail, $companyName)
            ->addHeader('MIME-Version', '1.0')
            ->addHeader('Content-Transfer-Encoding', '8bit')
            ->addHeader('X-Mailer:', 'PHP/'.phpversion())
            ->setBodyHtml($msgbody)
            ->setFrom($companyEmail, $companyName)
            ->addTo('support@staffchecking.com', 'StaffChecking Support')
            ->addTo('support@staffchecking.com', 'StaffChecking Support')
            ->setSubject('StaffChecking Alert! New Letter of Authorization!');

        return $mail->send();
        }
        
    }
    
    
    public function supportMail($formDatas, $photoName){
        
        $html = new Zend_View();
        $html->setScriptPath(APPLICATION_PATH . '/views/scripts/email-template/');
        $html->assign(array('name' => $formDatas['name'], 
                            'email' => $formDatas['email'],
                            'message' => $formDatas['message'],
                            'photoname' => $photoName
                     ));

        $msgbody = $html->render('support.phtml');
        
        $mail = new Zend_Mail();
        $mail->setReplyTo($formDatas['email'], $formDatas['name'])
            ->addHeader('MIME-Version', '1.0')
            ->addHeader('Content-Transfer-Encoding', '8bit')
            ->addHeader('X-Mailer:', 'PHP/'.phpversion())
            ->setBodyHtml($msgbody)
            ->setFrom($formDatas['email'], $formDatas['name'])
            ->addTo('support@staffchecking.com', 'StaffChecking Support')
//            ->addTo('media@staffchecking.com', 'StaffChecking Support')
            ->setSubject('StaffChecking Support');

        return $mail->send();
        
    }
    
    public function faqsMail($formDatas){
        
        $html = new Zend_View();
        $html->setScriptPath(APPLICATION_PATH . '/views/scripts/email-template/');
        $html->assign(array('name' => $formDatas['name'], 
                            'companyName' => $formDatas['company_name'], 
                            'email' => $formDatas['email'],
                            'question' => $formDatas['message'],
                     ));

        $msgbody = $html->render('faqs.phtml');
        
        $mail = new Zend_Mail();
        $mail->setReplyTo($formDatas['email'], $formDatas['company_name'])
            ->addHeader('MIME-Version', '1.0')
            ->addHeader('Content-Transfer-Encoding', '8bit')
            ->addHeader('X-Mailer:', 'PHP/'.phpversion())
            ->setBodyHtml($msgbody)
            ->setFrom($formDatas['email'], $formDatas['company_name'])
            ->addTo('support@staffchecking.com', 'StaffChecking Support')
            ->addTo('media@staffchecking.com', 'StaffChecking Support')
            ->setSubject('StaffChecking FAQs');
        
        return $mail->send();
        
    }
    
    
    public function recoveryMail($formDatas, $newPass){
        
        $html = new Zend_View();
        $html->setScriptPath(APPLICATION_PATH . '/views/scripts/email-template/');
        $html->assign(array('email' => $formDatas['email'], 
                            'newPass' => $newPass
                     ));

        $msgbody = $html->render('recovery.phtml');
        
        $mail = new Zend_Mail();
        $mail->setReplyTo($formDatas['email'], 'New Password')
            ->addHeader('MIME-Version', '1.0')
            ->addHeader('Content-Transfer-Encoding', '8bit')
            ->addHeader('X-Mailer:', 'PHP/'.phpversion())
            ->setBodyHtml($msgbody)
            ->setFrom($formDatas['email'], 'New Password')
            ->addTo('support@staffchecking.com', 'StaffChecking Support')
            ->addTo($formDatas['email'], 'StaffChecking Support')
            ->setSubject('StaffChecking New Password');
        
        return $mail->send();
        
    }


    /**
     * Email from Advertisement page
     * @param array $formdData
     * @return int
     */
    public function sendAdvertisement($formData = array())
    {
        $name           =   $formData['company_name'];
        $companyName    =   $formData['company_name'];
        $address        =   $formData['address'];
        $zip            =   $formData['zip'];
        $telephone      =   $formData['telephone'];
        $email          =   $formData['email'];
        $message        =   $formData['message'];

        $msgbody ="
            <html>                                            
            <body style='width: 100%; background: #ededed; padding: 20px 0 25px 0;'>
                <div id='wrapper' style='width: 600px; margin: 0 auto; background: #fff; padding: 1px 20px 20px 20px;'>
                    <h1 style='text-decoration: none;'>Good Day StaffChecking Support!</h1><br />
                    <div>
                    <span>
                        There's a new message from advertisement page!<br />
                        Below are the informations:<br /><br />
                    </span>
                    </div>
                    <div>
                    <strong>Name:</strong> {$name} <br />
                    <strong>Company Name: </strong> {$companyName} <br />
                    <strong>Address:</strong> {$address} <br />
                    <strong>Zip Code:</strong> {$zip}<br />
                    <strong>Telephone:</strong> {$telephone}<br />
                    <strong>Email:</strong> {$email}<br /><br />
                    <strong>Message:</strong> {$message}<br /><br />
                    </div>
                    Thank you, <br />
                    StaffChecking.com Team
                </div>
            </body>                                
            </html>
            ";

        $mail = new Zend_Mail();
        $mail->setReplyTo('support@staffchecking.com', 'StaffChecking')
            ->addHeader('MIME-Version', '1.0')
            ->addHeader('Content-Transfer-Encoding', '8bit')
            ->addHeader('X-Mailer:', 'PHP/'.phpversion())
            ->setBodyHtml($msgbody)
            ->setFrom('support@staffchecking.com', 'StaffChecking Support!')
            ->addTo('support@staffchecking.com', 'StaffChecking Support Self Email')
//            ->addTo('media@staffchecking.com', 'StaffChecking Support Self Email')
            ->setSubject('StaffChecking Alert! Message from Advertisement Page!');
        
        return $mail->send();
    }

}
?>