<?php 
class Zend_Controller_Action_Helper_ValidatesAccount extends Zend_Controller_Action_Helper_Abstract 
{
	 public function changeUsername($formDatas = array())
    {
        $errors = array();
        
        // username
        $validator = new Zend_Validate_Db_RecordExists(array('table' => Zend_Registry::get('tablePrefix') . 'users', 'field' => 'username'));
        if ($validator->isValid($formDatas['new_username'])) {
            $errors['new_username'] = 'Username is existed, please try again.';
        } 

        $validator = new Zend_Validate_EmailAddress();
        if (!$validator->isValid($formDatas['new_username'])) {        
            $errors['email'] = 'Email address is invalid';
        }

        return $errors;
    }

    public function changePassword($formDatas = array())
    {
        $errors = array();
        // password
        $validator = new Zend_Validate_StringLength(array('min' => 6));
        if ($validator->isValid($formDatas['new_password'])) {
            $validator = new Zend_Validate_Identical($formDatas['new_password']);
            if (!$validator->isValid($formDatas['new_password2'])) {
                $errors['password'] = 'Password must be identical.';
            }
        } else {
            $errors['password'] = 'Password must altest 6 characters.';
        }
        return $errors;
    }
}
?>