<?php
class Application_Model_Tables_Categories extends Zend_Db_Table_Abstract
{
	
	/**
	 * Set database table name
	 */
	protected $_name = 'categories';
	
	
	/**
	 * Set table prefix
	 */ 
	public function __construct() 
	{
		// Construct the table prefix
		$this->_name = Zend_Registry::get('tablePrefix') . $this->_name;
		parent::__construct();
	}
	
	
	/**
     *
     * @param array $formDatas
     * @return mixed
     */
	public function insertCategories($formDatas = array())
	{
		$datas = array(
            'alias'         => $formDatas['alias'],
            'parent'        => $formDatas['parent'], 
            'weight'        => $formDatas['weight'],
            'name'          => $formDatas['name'],
            'description'   => $formDatas['description'],
            'status'        => $formDatas['status'],
    	    'date_modified' => new Zend_Db_Expr('NOW()'),
        );
        
		return $this->insert($datas);

	}
    
    
    /**
     *
     * @param array $formDatas
     * @return int
     */
	public function updateCategories($formDatas = array())
	{
		$datas = array(
            'alias'         => $formDatas['alias'],
            'parent'        => $formDatas['parent'],
            'weight'        => $formDatas['weight'],   
            'name'          => $formDatas['name'],
            'description'   => $formDatas['description'],
            'status'        => $formDatas['status'],
            'date_modified' => new Zend_Db_Expr('NOW()'),
        );
        
	    return $this->update($datas, 'category_id = ' . $formDatas['category_id']);
	}
    
}