<?php
/**
 * Users model 
 * @author Zaine
 */
class Application_Model_Tables_Connection extends Zend_Db_Table_Abstract
{

	/**
	 * Set database table name 
	 */
	protected $_name = 'connection';
	
	
	/**
	 * Set table prefix 
	 */ 
	public function __construct() 
	{
		// Construct the table prefix	
		$this->_name = Zend_Registry::get('tablePrefix') . $this->_name;
		parent::__construct();
	}


	/**
	 *  Inserting Connection
	 *  @param int $userId
	 *  @param int $userId
	 *  @return mixed 
	 */
	public function addConnection($userId, $connectedId)
	{
		$date = date("Y-m-d H:i:s");
		$data = array(
			'account_id' => $userId,
			'connected_id' => $connectedId,
			'date_added' => $date,
			'date_modified' => $date,
			'status' => 'not-deleted',
		);

		$this->insert($data);
	}


	/**
	 *  Remove Connection
	 *  @param int $userId
	 *  @param int $connectedId
	 *  @return int
	 */
	public function removeConnection($userId, $connectedId)
	{
		$date = date("Y-m-d H:i:s");
		$data = array(
			'date_modified' => $date,
			'status' => 'deleted',
		);

		$where = $this->getAdapter()->quoteInto("account_id = $userId && connected_id = $connectedId && status = 'not-deleted'");
		$this->update($data, $where);
	}


	/**
	 *  restore Connection if already exist
	 *  @param int $userId
	 *  @param int $connectedId
	 *  @return int
	 */
	public function restoreConnection($userId, $connectedId)
	{
		$date = date("Y-m-d H:i:s");
		$data = array(
			'date_modified' => $date,
			'status' => 'not-deleted',
		);

		$where = $this->getAdapter()->quoteInto("account_id = $userId && connected_id = $connectedId && status ='deleted'");
		$this->update($data, $where);
	}


	/**
	 *	permanently delete Connection
	 */
	public function deleteConnection($userId, $connectedId)
	{
		$where = $this->getAdapter()->quoteInto("account_id = $userId && connected_id = $connectedId");
		$this->delete($where);
	}

}
?>