<?php
class Application_Model_Tables_Employeesmark extends Zend_Db_Table_Abstract
{

	/**
	 * Set database table name 
	 */
	protected $_name = 'employees_mark';
	
	
	/**
	 * Set table prefix 
	 */ 
	public function __construct() 
	{
		// Construct the table prefix	
		$this->_name = Zend_Registry::get('tablePrefix') . $this->_name;
		parent::__construct();
	}


	public function addMarkType($employeeId, $markType)
	{
		$date = date("Y-m-d H:i:s");
		$userId = Zend_Auth::getInstance()->getIdentity()->user_id;

		$data = array(
			'user_id' => $userId,
			'employee_id' => $employeeId,
			'mark_type' => $markType,
			'created' => $date,
			'modified' => $date,
			'status' => 'not-deleted',
		);

		$this->insert($data);
	}


	public function removeMarkType($employeeId)
	{
		$date = date("Y-m-d H:i:s");
		$userId = Zend_Auth::getInstance()->getIdentity()->user_id;

		$data = array(
			'modified' => $date,
			'status' => 'deleted',
		);

		$where = $this->getAdapter()->quoteInto("employee_id = $employeeId && user_id = $userId");
		$this->update($data, $where);
	}


	public function restoreMarkType($employeeId, $markType)
	{
		$date = date("Y-m-d H:i:s");
		$userId = Zend_Auth::getInstance()->getIdentity()->user_id;

		$data = array(
			'created' => $date,
			'modified' => $date,
			'mark_type' => $markType,
			'status' => 'not-deleted',
		);

		$where = $this->getAdapter()->quoteInto("employee_id = $employeeId && user_id = $userId");
		$this->update($data, $where);
	}



}
?>