<?php
class Application_Model_Tables_Products extends Zend_Db_Table_Abstract
{
	
	/**
	 * Set database table name
	 */
	protected $_name = 'products';
	
	
	/**
	 * Set table prefix
	 */ 
	public function __construct() 
	{
		// Construct the table prefix
		$this->_name = Zend_Registry::get('tablePrefix') . $this->_name;
		parent::__construct();
	}
	
	
	/**
	 * Insert data
	 */
	public function insertProducts($formDatas = array())
	{
		$datas = array(
            'alias'                    => $formDatas['alias'],
            'title'                    => $formDatas['title'],
            'description'		       => $formDatas['description'],
            'image_filename'	       => $formDatas['image_filename'],
            'image_thumb_filename'     => $formDatas['image_thumb_filename'],
            'date_displayed'           => $formDatas['date_displayed'], 
            'date_expired'		       => $formDatas['date_expired'],
            'status'                   => $formDatas['status'],
    	    'date_modified'		       => new Zend_Db_Expr('NOW()'),
        );
        	   
		return $this->insert($datas);
	}
    
    
    /**
	 * Update data
	 */
	public function updateProducts($formDatas = array())
	{
		$datas = array(
		    'alias'                    => $formDatas['alias'],  
            'title'                    => $formDatas['title'],
            'description'		       => $formDatas['description'],
            'date_displayed'           => $formDatas['date_displayed'],
            'date_expired'		       => $formDatas['date_expired'],
            'status'                   => $formDatas['status'],
			'date_modified'		       => new Zend_Db_Expr('NOW()'),
        );
       
        // Check first image
        if ($formDatas['image_filename'] != null) {
         	$datas['image_filename']          = $formDatas['image_filename'];
         	$datas['image_thumb_filename']    = $formDatas['image_thumb_filename'];
        }
        
	    return $this->update($datas, 'product_id = ' . (int)$formDatas['product_id']);
	}

    
}