<?php
class Application_Model_Tables_Relproducts extends Zend_Db_Table_Abstract
{
	
	/**
	 * Set database table name
	 */
	protected $_name = 'rel_products';
	
	
	/**
	 * Set table prefix
	 */ 
	public function __construct() 
	{
		// Construct the table prefix
		$this->_name = Zend_Registry::get('tablePrefix') . $this->_name;
		parent::__construct();
	}
	
	
	/**
	 * Insert data
	 */
	public function insertRelproducts($formDatas = array())
	{
		$datas = array(
            'product_id'    => $formDatas['product_id'],
            'category_id'   => $formDatas['category_id'],
            'type'          => $formDatas['type'],
        );
        
		return $this->insert($datas);
	}
    
    
    /**
     * Delete category of the videos
     */
    public function deleteRelproducts($formDatas = array())
    {
        $where = array(
            'product_id'=> $formDatas['product_id'],
            'type'      => $formDatas['type']
        );
        
        return $this->delete('product_id = ' . (int)$formDatas['product_id']);
    }
    
    
    /**
     * This function will get products using category
     * 
     */ 
    public function selectCategoryWithProducts($categoryId = 0)
    {
        // Connect to database
        $db     = Zend_Db_Table::getDefaultAdapter();
        $prefix = Zend_Registry::get('tablePrefix');
        $query  = new Zend_Db_Select($db);
        
        // Build Sql query
        $query = $db->select();
        $query->from($prefix .  'products');
        $query->joinUsing($prefix . 'rel_products', 'product_id');
        $query->where('category_id = ?', (int)$categoryId);
        $query->where("status = 'enable'");
        
        // Fetch the query
        return $db->fetchAll($query);
    }
}