<?php
class Application_Model_Tables_Reply extends Zend_Db_Table_Abstract
{

	/**
	 * Set database table name 
	 */
	protected $_name = 'replies';
	
	
	/**
	 * Set table prefix 
	 */ 
	public function __construct() 
	{
		// Construct the table prefix	
		$this->_name = Zend_Registry::get('tablePrefix') . $this->_name;
		parent::__construct();
	}


	/**
	 *  Send Reply to a message
	 *  @param array $formDatas
	 *  @return mixed
	 */
	public function addReply($formDatas = array())
	{
		$date = date("Y-m-d H:i:s");
		$userId = Zend_Auth::getInstance()->getIdentity()->user_id;

		$data = array(
			'message_id' => $formDatas['message_id'],
			'sender_id' => $userId,
			'receiver_id' => $formDatas['receiver_id'],
			'subject' => $formDatas['subject'],
			'message' => $formDatas['message'],
			'date_created' => $date,
			'date_modified' => $date,
			'connected' => 0,
			'read' => 0,
			'location' => $formDatas['location'],
			'status' => $formDatas['location'],
		);

		$this->insert($data);
	}

}
?>