<?php
/**
 * Users model 
 * @author Reynald
 */
class Application_Model_Tables_Users extends Zend_Db_Table_Abstract
{
	
	/**
	 * Set database table name 
	 */
	protected $_name = 'users';
	
	
	/**
	 * Set table prefix 
	 */ 
	public function __construct() 
	{
		$this->_name = Zend_Registry::get('tablePrefix') . $this->_name;
		parent::__construct();
	}
	
	
	/**
     * Insert new date to _users.
     *
     * @param array $formDatas
     * @param string $privilege
     * @return mixed
     */
	public function insertUsers($formDatas = array(), $privilege = 'employer')
	{
		$username = $formDatas['company_email'];
		$now = date("Y-m-d H:i:s");
		$datas = array(
			'username'			=> $username,
			'password'			=> md5($formDatas['password']),
			'password_human' 	=> $formDatas['password'],
			'privilege'			=> $privilege,
			'status'			=> 'inactive',
			'deleted'			=> 'no',
			'link'				=> $formDatas['link'],
			'created'  			=> $now,
			'modified' 			=> $now,
        );
		return $this->insert($datas);
	}
    
    
    /**
     * Update the _users.
     *
     * @param array $formDatas
     * @return int
     */
	public function updateUsers($formDatas = array())
	{
		$datas = array(
			'username'			=> $formDatas['username'],
			'password'			=> md5($formDatas['password']),
			'password_human' 	=> $formDatas['password'],
			'privilege'			=> $formDatas['privilege'],
        );
                         
	   return $this->update($datas, 'user_id = ' . $formDatas['user_id']);
	}
    
    
    /**
     * Get the _users with _user_infos
     *
     * @param int $userId
     * @return array
     */
    public function selectUserWithUserInfo($userId = 0)
    {
        $db     = Zend_Db_Table::getDefaultAdapter(); 
        $prefix = Zend_Registry::get('tablePrefix');
        $query  = new Zend_Db_Select($db);

        $query = $db->select();
        $query->from($prefix .  'users as u');
        $query->joinUsing($prefix . 'user_infos', 'user_id');
        $query->where('u.user_id = ?', (int)$userId);

        return $db->fetchRow($query);
    }


    /**
     *	update Username 
     *  @param array $formDatas
     *  @return int
     */
    public function updateUsername($formDatas = array())
	{
		$userId = Zend_Auth::getInstance()->getIdentity()->user_id;
		$datas = array(
			'username' => $formDatas['new_username'],
		);

		return $this->update($datas, 'user_id = ' . $userId);
	}


	/**
	 *  Update Users Password
	 *  @param array $formDatas
	 *  @return int
	 */
	public function updatePassword($formDatas = array())
	{
		$userId = Zend_Auth::getInstance()->getIdentity()->user_id;
		$newPassword = md5($formDatas['new_password']);
		$datas = array(
			'password' => $newPassword,
			'password_human' => $formDatas['new_password'],
		);
		return $this->update($datas, 'user_id = ' . $userId, 1);
	}


	/**
	 *  Recover Password ( Send to users email)
	 *  @param array $formDatas
	 *  @param string $newPass
	 *  @return int
	 */
	public function recoverPassword($formDatas = array(), $newPass)
	{
		$newPassword = md5($newPass);
		$datas = array(
			'password' => $newPassword,
			'password_human' => $newPass,
		);
		
		$where = $this->getAdapter()->quoteInto('username = ?', $formDatas['email']);
		$this->update($datas, $where);
	}

	/**
	 * Update Last Login
	 */
	public function updateLastLogin($userId)
	{
		$datas = array(
			'last_login' => new Zend_Db_Expr('NOW()')
		);

		$where['user_id = ?'] = $userId;
		$this->update($datas, $where);
	}
    
}