<?php

class Admin_CompaniesController extends Zend_Controller_Action
{
	
	/**
     * Before dispatching, check the security in general
     */
    public function preDispatch() 
    {
        $this->view->auth = Zend_Auth::getInstance();
        if (!$this->view->auth->hasIdentity()) { 
            $this->_helper->flashMessenger->addMessage('<p class="msg error">Error accessing the resquested page.</p>');
            $this->_redirect('/');
        }
        
    }
	
    
	/**
	 * Initialize action controller here
	 */
    public function init()
    {
    	// Set the flash messenger	
		$this->view->flashMessenger = $this->_helper->flashMessenger->getMessages();

        $this->urlSession = new Zend_Session_Namespace('urlSession');
	}


	/**
     * 
     */
    public function indexAction()
    {
        $this->view->headTitle('Companies Page');

        $this->view->bodyId = 'admin-companies-page';        

        $companies = new Admin_Model_Tables_Companies();
        $this->view->row = $companies->fetchAll($companies->select());
    }


    public function adminViewCompanyAction()
    {
    	$this->view->headTitle('View Company');
    	$this->view->bodyId = 'view-company-page';
        $this->urlSession->url = (!empty($_SERVER['HTTPS'])) ? "https://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'] : "http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];

    	$this->request = $this->getRequest();
    	$id = $this->request->getParam('id');

    	$company = new Admin_Model_Tables_Companies();
    	$this->view->row = $company->fetchRow($company->select()->where("company_id = ?", $id));
    }


    public function adminEditCompanyAction()
    {
    	$this->view->headTitle('Edit Company');
    	$this->view->bodyId = 'edit-company-page';

    	$this->request = $this->getRequest();
    	$id = $this->request->getParam('id');

    	$company = new Admin_Model_Tables_Companies();
    	$this->view->row = $company->fetchRow($company->select()->where("company_id = ?", $id));

    	//if save button is click
    	if($this->getRequest()->isPost())
    	{
    		$id = $this->_request->getPost('id');
    		$company_name = $this->_request->getPost('company_name');
    		$company_address = $this->_request->getPost('company_address');
    		$company_phone = $this->_request->getPost('company_phone');
    		$company_fax = $this->_request->getPost('company_fax');
    		$company_email = $this->_request->getPost('company_email');
    		$first_name = $this->_request->getPost('first_name');
    		$middle_name = $this->_request->getPost('middle_name');
    		$last_name = $this->_request->getPost('last_name');
    		$designation = $this->_request->getPost('designation');
    		$type_of_company = $this->_request->getPost('type_of_company');
    		$status = $this->_request->getPost('status');

    		if(empty($id) || empty($company_name) || empty($company_address) || empty($company_phone) || empty($company_fax) || empty($company_email) || empty($first_name) || empty($middle_name) || empty($last_name) || empty($designation) || empty($type_of_company) || empty($status) )
    		{
    			$this->view->flashMessenger[] = "<div class='msg error'>One of the fields are empty.</div>";
                $this->_redirect('admin/companies/');      
    		}
    		else
    		{
    			$formDatas = $this->getRequest()->getPost();
                
                $company = new Admin_Model_Tables_Companies();
                $company->adminUpdateCompany($formDatas);
                $this->_redirect('admin/companies');
    		}
    	}
    }


    public function adminDeleteCompanyAction()
    {
        $this->request = $this->getRequest();
        $id = $this->request->getParam('id');

        $company = new Admin_Model_Tables_Companies();
        $company->adminDeleteCompany($id);

        $url =  $this->urlSession->url;
        $this->_redirect($url);
    }


    public function adminDeletedCompaniesAction()
    {
        $this->view->headTitle('Deleted Companies Pages');
        $this->view->bodyId = 'deleted-companies-page';

        $companies = new Admin_Model_Tables_Companies();
        $this->view->row = $companies->fetchAll($companies->select()->where("status = 'deleted'"));

        $this->request = $this->getRequest();
        $id = $this->request->getParam('id');

        if(!empty($id))
        {
            $company = new Admin_Model_Tables_Companies();
            $company->adminUndeleteCompany($id);
            $this->_redirect('admin/companies/admin-deleted-companies');
        }
    }


    public function adminUndeletedCompaniesAction()
    {
        $this->view->headTitle('Undeleted Companies Pages');
        $this->view->bodyId = 'undeleted-companies-page';

        $this->urlSession->url = (!empty($_SERVER['HTTPS'])) ? "https://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'] : "http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];

        $companies = new Admin_Model_Tables_Companies();
        $this->view->row = $companies->fetchAll($companies->select()->where("status != 'deleted'"));
    }


    public function adminAddEmployeeAction()
    {
        $this->view->headTitle('Add Employee');
        $this->view->bodyId = 'admin-add-employee-page';

        $this->request = $this->getRequest();
        $this->view->user_id = $this->request->getParam('id');

        if($this->getRequest()->isPost())
        {
            $user_id = $this->_request->getPost('user_id');
            $first_name = $this->_request->getPost('first_name');
            $middle_name = $this->_request->getPost('middle_name');
            $last_name = $this->_request->getPost('last_name');
            $designation = $this->_request->getPost('designation');
            $last_salary = $this->_request->getPost('last_salary');
            $unpaid_loan = $this->_request->getPost('unpaid_loan');
            $unpaid_advance = $this->_request->getPost('unpaid_advance');
            $attendance = $this->_request->getPost('attendance');
            $employment_status = $this->_request->getPost('employment_status');
            $employment_action = $this->_request->getPost('employment_action');
            $remarks = $this->_request->getPost('remarks');
            $recommendation = $this->_request->getPost('recommendation');

            if(empty($user_id) || empty($first_name) || empty($middle_name) || empty($last_name) || empty($designation) || empty($last_salary) || empty($unpaid_loan) || empty($unpaid_advance) || empty($attendance) || empty($employment_action) || empty($employment_status) || empty($remarks) || empty($recommendation) )
            {
                $this->view->flashMessenger[] = "<div class='msg error'>One of the fields are empty.</div>";
                $this->_redirect('admin/companies/');                
            }
            else
            {
                //form data
                $formDatas = $this->getRequest()->getPost();
                //instantiating employers table
                $employee = new Admin_Model_Tables_Employers();
                //uploaded photo
                $adapter = new Zend_File_Transfer_Adapter_Http(); 
                $adapter->addValidator('Size', false, 40000);
                $photo = $adapter->getFileName();

                //upload path
                $uploadPath = "/home/puvprime/public_html/rad05/public/uploads/profile_pic";
                
                if(!empty($photo))
                {
                    if($adapter->isValid())
                    {
                        //function for inserting and updating photoname & at the same time return the photoname(id)
                        $photoName = $employee->adminAddEmployee($formDatas, $photo);
                        
                        //get the name, convert it to array and remove the last element of the array
                        $tmpName = array_slice(explode(".", $photoName), 0, -1);
                        //implode the array which result to the name of the folder
                        $folderName = implode("", $tmpName);
                        //make the folder name (base on the id of the user)
                        $createFolder = shell_exec("mkdir {$uploadPath}/{$folderName}");

                        //destination of the uploaded
                        $adapter->setDestination("{$uploadPath}/{$folderName}");
                        
                        //rename the file to be uploaded
                        $adapter->addFilter('Rename', $photoName);
                        //upload the file running the filter
                        $adapter->receive();
                        $url =  $this->urlSession->url;
                        $this->_redirect($url);
                    }
                    else
                    {
                        $this->view->flashMessenger[] = "<div class='msg error'>Either the file is not an image or it exceeds the maximum upload size.</div>";
                        $this->_redirect('admin/companies');
                    }
                }
                else
                {
                    $photo_name = $employee->adminAddEmployee($formDatas, $photo);
                    
                    //photo_name returns the id of the data if the photo is empty
                    $folder_name = $uploadPath . "/" .$photo_name;
                    //creating a folder for photo
                    $createFolder = shell_exec("mkdir {$folder_name}");
                    @chmod($folder_name, 0777);
                    $url =  $this->urlSession->url;
                    $this->_redirect($url);
                }
                
            }
        }
        
    }
     
}  