<?php

class Admin_UsersController extends Zend_Controller_Action
{
	
	/**
	 * Before dispatching, check the security in general
 	 */
	public function preDispatch() 
	{
		$this->view->auth = Zend_Auth::getInstance();
		if (!$this->view->auth->hasIdentity()) { 
			$this->_helper->flashMessenger->addMessage('<p class="msg error">Error accessing the resquested page.</p>');
			$this->_redirect('/');
		}
        
        // Check Privilege
        // Controllers and views are accessibleonly by admin
        if (Zend_Auth::getInstance()->getStorage()->read()->privilege != 'admin') {
            $this->_helper->flashMessenger->addMessage('<p class="msg error">Error accessing the resquested page.</p>');
            $this->_redirect('/');
        }
	}
	
    
	/**
	 * Initialize action controller here
	 */
    public function init()
    {
    	// Set the flash messenger	
		$this->view->flashMessenger = $this->_helper->flashMessenger->getMessages();
	}


	/**
     * 
     */
    public function indexAction()
    {        
        $this->view->headTitle('Users');

        $users = new Admin_Model_Tables_Users();
        $result = $users->fetchAll($users->select()->order('created DESC'));
        $this->view->rows = $result;
    }


    public function viewAction()
    {
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        if(!isset($userId) || empty($userId))
        {
            $this->_redirect('/');
        }

        $id = $this->_request->getParam('id');
        if(empty($id))
        {
            $this->_redirect('admin/users');
        }

        $adapter = Zend_Db_Table_Abstract::getDefaultAdapter();
        $select = new Zend_Db_Select($adapter);
        $select->from('staff_companies')
               ->joinInner('staff_users', 'staff_companies.user_id = staff_users.user_id')
               ->where("staff_users.user_id = $id");
        $results = $adapter->fetchRow($select);        
        $this->view->row = $results;
    }

    public function editUserAction(){
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        if(!isset($userId) || empty($userId))
        {
            $this->_redirect('/');
        }

        $id = $this->_request->getParam('id');
        if(empty($id))
        {
            $this->_redirect('admin/users');
        }

        $adapter = Zend_Db_Table_Abstract::getDefaultAdapter();
        $select = new Zend_Db_Select($adapter);
        $select->from('staff_companies')
               ->joinInner('staff_users', 'staff_companies.user_id = staff_users.user_id')
               ->where("staff_users.user_id = $id");
        $results = $adapter->fetchRow($select);        
        $this->view->row = $results; 
        
        $adapter2 = Zend_Db_Table_Abstract::getDefaultAdapter();
        $select2 = new Zend_Db_Select($adapter2);
        $select2->from('staff_users')
               ->where("user_id = $id");
        $results2 = $adapter->fetchRow($select2);        
        $this->view->row2 = $results2; 
        
        //if change password submit button is submitted
        if($this->getRequest()->getPost('password_submit'))
        {
            $oldPass = $this->_request->getPost('old_password');
            $newPass = $this->_request->getPost('new_password');
            $newPass2 = $this->_request->getPost('new_password2');
            if(empty($oldPass) || empty($newPass) || empty($newPass2))
            {
                echo "<script type='text/javascript'>alert('One of the Password field is empty!')</script>";
            }
            else
            {
                $formDatas = $this->getRequest()->getPost();
                $errors = $this->_helper->validatesAccount->changePassword($formDatas);
                if($errors == null)
                {
                    //$formDatas['id'] = $id;
                    $user = new Application_Model_Tables_Users();
                    $password = $user->fetchRow($user->select()->where('user_id = ' . $id, 1));
                    $oldPassword = md5($oldPass);
                    $currentPassword = $password['password'];
                    if($currentPassword != $oldPassword)
                    {
                        $this->view->flashMessenger[] = '<div class="msg error">Old Password does not Match.</div>';                ;
                    }
                    else
                    {
                        $user = new Admin_Model_Tables_Users();
                        $user->updatePassword($id,$formDatas);
                        //$this->view->flashMessenger[] = "<div class='msg done'>Password Succesfully Changed!</div>";
                        //$this->_helper->flashMessenger->addMessage('<p class="msg done">Password Succesfully Changed!</p>');
                        $notify = $this->_helper
                        ->interface
                        ->notify('Success', 'Password Succesfully Changed!', 'notify-success');
                        $this->_helper->flashMessenger->addMessage($notify);
                        $this->_redirect('admin/users/edit-user/id/'.$id);
                    }
                }
                else
                {
                    //display errors
//                    $message = '<ul>';
//                    foreach($errors as $error) {
//                        $message.= '<li>' . $error . '</li>';
//                    }
//                    $message.= '</ul>';
                    foreach($errors as $error) {
                        $message.= $error;
                    }
                    // $this->_helper->flashMessenger->addMessage('<div class="msg error">' . $message . '</div>');
                    $this->view->flashMessenger[] = '<div class="msg error">' . $message . '</div>';  
                    $this->view->formDatas = $formDatas;
                }  
            }
        }
        //end change password submit button is submitted
        
        //if update user submit button is submitted
        if($this->getRequest()->getPost('update_user')){
            $employer = new Application_Model_Tables_Companies();
            $row = $employer->fetchRow($employer->select()->where('user_id = ' . $id, 1));
            $this->view->row = $row;
            $origCompanyName = $row['company_name']; 
            if($this->getRequest()->isPost())
            {
                $companyName = $this->_request->getPost('company_name');
                $companyAddress  = $this->_request->getPost('company_address');
                $zipcode = $this->_request->getPost('zipcode');
                $companyPhone = $this->_request->getPost('company_phone');
                $companyFax = $this->_request->getPost('company_fax');
                $firstName = $this->_request->getPost('first_name');
                $middleName = $this->_request->getPost('middle_name');
                $lastName = $this->_request->getPost('last_name');
                $designation = $this->_request->getPost('designation');            
                $typeOfCompany = $this->_request->getPost('type_of_company');
                $status = $this->_request->getPost('status');
                
                $formDatas = $this->getRequest()->getPost();

                if(!empty($status)){
                    $user_status = new Admin_Model_Tables_Users();
                    $user_status->updateStatus($id,$formDatas);
                }
                
                $formDatas = $this->_helper->filterTags->filter($formDatas);
                $validator = new Zend_Validate_Db_RecordExists(array('table' => Zend_Registry::get('tablePrefix') . 'companies', 'field' => 'company_name'));

                if(empty($companyName) || empty($companyAddress) || empty($companyPhone) || empty($companyFax) || empty($firstName) || empty($middleName) || empty($lastName) || empty($designation) || empty($typeOfCompany) || empty($zipcode) )
                {
                    $this->view->flashMessenger[] = "<div class='msg error'>One of the fields are empty!</div>";
                    $this->view->formDatas = $formDatas;
                }
                elseif ($validator->isValid($companyName) && $companyName != $origCompanyName) 
                {
                    $this->view->flashMessenger[] = "<div class='msg error'>Company Name already existed, please try again.</div>";
                    $this->view->formDatas = $formDatas;
                }
                elseif(!ctype_digit($zipcode))
                {
                    $this->view->flashMessenger[] = "<div class='msg error'>Zip Code must be integer only.</div>";
                    $this->view->formDatas = $formDatas;
                }
                else
                {                
                    $errors = array();

                    $companies = new Admin_Model_Tables_Companies();

                    //Company Logo
                    $adapterLogo = new Zend_File_Transfer_Adapter_Http();
                    $adapterLogo->addValidator("Size", false, 1024000)
                                ->addValidator('Extension', false, array('jpg', 'jpeg', 'png'))
                                ->addValidator('ImageSize', false,
                                    array(
                                        'minwidth' => 10,
                                        'maxwidth' => 3000,
                                        'minheight' => 10,
                                        'maxheight' => 3000
                                    )
                                );
                    $fileLogo = $adapterLogo->getFileName();

                    if($fileLogo != NULL) { 
                        if (!$adapterLogo->isValid()) { 
                            $errors['logo'] = "<div class='msg error'>Company Logo is not an image or it exceeds the maximum upload size.</div>";
                        }
                    }

                    if(empty($errors))
                    {
                        

                        $companies->updateCompany($id,$formDatas);
                        
                        $notify = $this->_helper
                        ->interface
                        ->notify('Success', 'Profile Succesfully Updated.', 'notify-success');
                        $this->_helper->flashMessenger->addMessage($notify);
                        
                        
                        if($adapterLogo->isValid())
                        {
                            
                            $companies->photoName($id, $fileLogo);
                            
                            $filename = $adapterLogo->getFileName();

                            $fileInfo = $adapterLogo->getFileInfo();

                            $fileNameInfo = pathinfo($fileInfo['uploadedfile']['name']);

                            //Rename Image
                            $formDatas['photo_name'] = $id . '.' . $fileNameInfo['extension'];
                            
                            $uploadPathLogo = APPLICATION_PATH . "/../public/uploads/company_pic/{$id}";
                        
                            @mkdir($uploadPathLogo, 0777);
                            @chmod($uploadPathLogo, 0777);
                
                             
                            $adapterLogo->setDestination("public/uploads/company_pic/{$id}/");
                            //renaming/updating photo

                            $adapterLogo->addfilter("Rename", $formDatas['photo_name']);
                            
                            $adapterLogo->receive();
                            
                            // Get the file info i.e. tmp name, file name etc    
                            $filenames = $adapterLogo->getFileInfo();
                            // Get the first uploaded file info   
                            
                            if (trim($filenames['uploadedfile']['name']) != null) 
                            {
                                
                                // The first image file
                                $imageFilename  = $filenames['uploadedfile']['name'];

                                // Create thumbnail name
                                $imageThumbFilename = 'thumb_' . $formDatas['photo_name'];
                                
                                // Save to formDatas
                                $formDatas['image_thumb_filename'] = $imageThumbFilename;
                                
                                // Crop the image
                                $this->_helper
                                     ->Crop
                                     ->imageCrop(100, 80, "$uploadPathLogo/$imageFilename", "$uploadPathLogo/$imageThumbFilename");
                            }
                        }

                        $companies->updateCompany($id,$formDatas);
                        //$this->_helper->flashMessenger->addMessage('<p class="msg done">Profile Succesfully Updated.</p>');
                        $notify = $this->_helper
                        ->interface
                        ->notify('Success', 'Profile Succesfully Updated.', 'notify-success');
                        $this->_helper->flashMessenger->addMessage($notify);
                        $this->_redirect('admin/users/edit-user/id/'.$id);

                    }else{

                        foreach ($errors as $value) {
                            $this->view->flashMessenger[] = $value;
                        }
                    }
                }
            }
        }
        //end update user submit button is submitted
        
    } 
    
    public function editAccountAction()
    {
        $this->request = $this->getRequest();
        $userId = $this->request->getParam('id');
        
        if(empty($userId))
        {
            $this->_redirect('employer');
        }
        
        if(!empty($userId)){
        $employer = new Application_Model_Tables_Users();
        //fetch data for the first instance of viewing the page
        $this->view->row = $employer->fetchRow($employer->select()->where('user_id = ' . $userId, 1));
        $this->_redirect('admin/users/edit-user/id/'.$userId);
        }
    }

    public function pendingListAction()
    {
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        if(!isset($userId) || empty($userId))
        {
            $this->_redirect('/');
        }

        $users = new Admin_Model_Tables_Users();
        $results = $users->fetchAll($users->select()->where("status = ?", 'inactive')->where("deleted = ?", 'no')->where("privilege = ?", 'employer')->order('created DESC'));
        $this->view->rows = $results;
    }
     

    public function activeListAction()
    {
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        if(!isset($userId) || empty($userId))
        {
            $this->_redirect('/');
        }

        $users = new Admin_Model_Tables_Users();
        $results = $users->fetchAll($users->select()->where("status = ?", 'active')->where("deleted = ?", 'no')->where('privilege = ?', 'employer')->order('created DESC'));
        $this->view->rows = $results;
    }


    public function suspendedListAction()
    {
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        if(!isset($userId) || empty($userId))
        {
            $this->_redirect('/');
        }

        $users = new Admin_Model_Tables_Users();
        $results = $users->fetchAll($users->select()->where("status = ?", 'suspended')->where("deleted = ?", 'no')->where("privilege = ?", 'employer')->order('created DESC'));
        $this->view->rows = $results;
    }


    public function disapprovedListAction()
    {
        $userId = Zend_auth::getInstance()->getIdentity()->user_id;
        if(!isset($userId) || empty($userId))
        {
            $this->_redirect('/');
        }

        $users = new Admin_Model_Tables_Users();
        $results = $users->fetchAll($users->select()->where("status = ?", 'inactive')->where("deleted = ?", 'yes')->where("privilege = ?", 'employer')->order('created DESC'));
        $this->view->rows = $results;
    }


    public function deletedUsersListAction()
    {
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        if(!isset($userId) || empty($userId))
        {
            $this->_redirect('/');
        }

        $users = new Admin_Model_Tables_Users();
        $results = $users->fetchAll($users->select()->where("status != ?", 'inactive')->where("deleted = ?", 'yes')->where("privilege = ?", 'employer')->order("modified DESC"));
        $this->view->rows = $results;
    }


    public function suspendUserAction()
    {
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        $id = $this->_request->getParam('id');
        if(!isset($userId) || empty($userId) || empty($id))
        {
            $this->_redirect('/');
        }        

        $users = new Admin_Model_Tables_Users();
        $results = $users->fetchRow($users->select()->where("status = ?", 'active')->where("deleted = ?", 'no')->where("privilege = ?", 'employer')->where("user_id = ?", $id));
        if(count($results) > 0)
        {
            $users->suspendUser($id);
            $this->_redirect("admin/users/view/id/$id");
        }
    }


    public function activateUserAction()
    {
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        $id = $this->_request->getParam('id');
        if(!isset($userId) || empty($userId) || empty($id))
        {
            $this->_redirect('/');
        }

        $users = new Admin_Model_Tables_Users();
        $results = $users->fetchRow($users->select()->where("status = ?", 'suspended')->where("deleted = ?", 'no')->where("privilege = ?", 'employer')->where("user_id = ?", $id));
        if(count($results) > 0)
        {
            $users->activateUser($id);
            $this->_redirect("admin/users/view/id/$id");
        }
    }


    public function deleteUserAction()
    {
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        $id = $this->_request->getParam('id');
        if(!isset($userId) || empty($userId) || empty($id))
        {
            $this->_redirect('/');
        }

        $users = new Admin_Model_Tables_Users();
        $results = $users->fetchRow($users->select()->where("deleted = ?", 'no')->where("privilege = ?", 'employer')->where("user_id = ?", $id));
        if(count($results) > 0)
        {
            $users->deleteUser($id);
            $this->_redirect("admin/users/view/id/$id");
        }
    }


    public function restoreUserAction()
    {
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        $id = $this->_request->getParam('id');
        if(!isset($userId) || empty($userId) || empty($id))
        {
            $this->_redirect('/');
        }

        $users = new Admin_Model_Tables_Users();
        $results = $users->fetchRow($users->select()->where("privilege = ?", 'employer')->where("deleted = ?", 'yes'));
        if(count($results) > 0)
        {
            $users->restoreUser($id);
            $this->_redirect("admin/users/view/id/$id");
        }
    }


    public function approveUserAction()
    {
        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
        if(!isset($userId) || empty($userId))
        {
            $this->_redirect('/');
        }

        $id = $this->_request->getParam('id');        
        $adapter = Zend_Db_Table_Abstract::getDefaultAdapter();
        $select = new Zend_Db_Select($adapter);
        $select->from('staff_companies')
           ->joinInner('staff_users', 'staff_companies.user_id = staff_users.user_id')
           ->where("staff_users.status = 'inactive'")
           ->where("staff_users.deleted = 'no'")
           ->where("staff_users.user_id = $id");
        $results = $adapter->fetchRow($select);    
        
        
        if(count($results) > 0)  
        {
            $users = new Admin_Model_Tables_Users();
            $users->approveUser($id);
            
            $this->_helper->AdminResponseEmail->approvedMail($results);
            
            $notify = $this->_helper
                           ->interface
                           ->notify('Welcome', 'User Succesfully Activated.', 'notify-success');
                           $this->_helper->flashMessenger->addMessage($notify);      
                           
            $this->_redirect("admin/users/view/id/$id");
        }
    }


    public function disapproveUserAction()
    {
        
        $userId = Zend_auth::getInstance()->getIdentity()->user_id;
        if(!isset($userId) || empty($userId))
        {
            $this->_redirect('/');
        }

        $id = $this->_request->getParam('id');
        $adapter = Zend_Db_Table_Abstract::getDefaultAdapter();
        $select = new Zend_Db_Select($adapter);
        $select->from('staff_companies')
           ->joinInner('staff_users', 'staff_companies.user_id = staff_users.user_id')
           ->where("staff_users.status = 'inactive'")
           ->where("staff_users.deleted = 'no'")
           ->where("staff_users.user_id = $id");
        $results = $adapter->fetchRow($select);

        if(count($results))
        {
            $users = new Admin_Model_Tables_Users();      
            $users->disapproveUser($id);                
            
            $this->_helper->AdminResponseEmail->disapprovedMail($results);
            
            $notify = $this->_helper
                           ->interface
                           ->notify('Welcome', 'User Succesfuly Deactivated.', 'notify-success');
                           $this->_helper->flashMessenger->addMessage($notify);            
                           
            $this->_redirect("admin/users/view/id/$id");
        }
    }
    
    
    public function accountVerificationAction(){
        $loaId = $this->_getParam('loaId');
        $bpId = $this->_getParam('bpId');
        
        $company = new Admin_Model_Tables_Companies();

        if(isset($loaId)){

            $formDatas = $company->getCompanyInfo($loaId);
            
            $company->updateAccountVerification($loaId, $formDatas['letter_of_authorization_status'], 'LOA');
            
            $this->_helper->AdminResponseEmail->verificationAccount($formDatas, 'LOA');   
            
            $notify = $this->_helper
                           ->interface
                           ->notify('','Letter of Authorization has been Succesfully Update.', 'notify-success');
                           $this->_helper->flashMessenger->addMessage($notify);        
                           
            $this->_redirect('admin/users/view/id/'.$loaId);
            
        }elseif(isset($bpId)){
            
            $formDatas = $company->getCompanyInfo($bpId);

            $company->updateAccountVerification($bpId, $formDatas['business_permit_status'], 'BP');
            
            $this->_helper->AdminResponseEmail->verificationAccount($formDatas, 'BP'); 
            
            $notify = $this->_helper
                           ->interface
                           ->notify('','Business Permit has been Succesfully Update.', 'notify-success');
                           $this->_helper->flashMessenger->addMessage($notify);    
                           
            $this->_redirect('admin/users/view/id/'.$bpId);
        }else{
            
            
            
            
        }
        
        
        
        
    }
    
    
    
    
    
//    public function editProfileAction(){
//        
//        $userId = Zend_Auth::getInstance()->getIdentity()->user_id;
//        if(!isset($userId) || empty($userId))
//        {
//            $this->_redirect('/');
//        }
//
//        $id = $this->_request->getParam('id');
//        if(empty($id))
//        {
//            $this->_redirect('admin/users');
//        }
//
//        $adapter = Zend_Db_Table_Abstract::getDefaultAdapter();
//        $select = new Zend_Db_Select($adapter);
//        $select->from('staff_companies')
//               ->joinInner('staff_users', 'staff_companies.user_id = staff_users.user_id')
//               ->where("staff_users.user_id = $id");
//        $results = $adapter->fetchRow($select);        
//        $this->view->row = $results;
//        
//        
//        
//        
//    }
    
    
}