<?php 
class Zend_Controller_Action_Helper_Validates extends Zend_Controller_Action_Helper_Abstract 
{


    /**
     * Credential validations
     */
    function credentials($formDatas = array())
    {
        
        $errors = array();
        
        // username
        $validator = new Zend_Validate_Db_RecordExists(array('table' => Zend_Registry::get('tablePrefix') . 'users', 'field' => 'username'));
        if ($validator->isValid($formDatas['company_email'])) {
            $errors['company_email'] = 'Username is existed, try again.';
        }
       
		// password
        $validator = new Zend_Validate_StringLength(array('min' => 6));
		if ($validator->isValid($formDatas['password'])) {
			$validator = new Zend_Validate_Identical($formDatas['password']);
			if (!$validator->isValid($formDatas['re_password'])) {
				$errors['password'] = 'Password must be identical.';
			}
		} else {
			$errors['password'] = 'Password must altest 6 characters.';
		}
        
        return $errors;
    }
       
    
    /**
     * User infos field validations 
     */
    public function userInfoFields($formDatas = array())
    {
        
        $errors = array();
        
        // firstname
        $validator = new Zend_Validate_StringLength(array('min' => 1));
        if (!$validator->isValid($formDatas['firstname'])) {
        	$errors['firstname'] = 'Firstname is required.';
        }
        
        // lastname
        $validator = new Zend_Validate_StringLength(array('min' => 1));
        if (!$validator->isValid($formDatas['lastname'])) {
        	$errors['lastname'] = 'Lastname is required.';
        }
        
  		// email
        $validator = new Zend_Validate_EmailAddress();
        if (!$validator->isValid($formDatas['email'])) {		
			$errors['email'] = 'Email address is invalid';
		}
        
        return $errors;
    }
    
    
    /**
     * Order validations
     */
    public function orders($formDatas = array()) 
    {
        $errors = array();
        
        // quantity_type
        $validator = new Zend_Validate_StringLength(array('min' => 1));
        if (!$validator->isValid($formDatas['quantity_type'])) {
            $errors['quantity_type'] = 'Quantity type is required.';
        }
        
        // quantity_no
        $validator = new Zend_Validate_StringLength(array('min' => 1));
        if (!$validator->isValid($formDatas['quantity_no'])) {
            $errors['quantity_no'] = 'Quantity no is required.';
        }
    }

}
