<?php
class Admin_Model_Tables_Userinfos extends Zend_Db_Table_Abstract
{
	

	/**
	 * Set database table name 
	 */
	protected $_name = 'user_infos';
	
    
	/**
	 * Set table prefix
	 */ 
	public function __construct() 
	{
		// Construct the table prefix	
		$this->_name = Zend_Registry::get('tablePrefix') . $this->_name;
		parent::__construct();
	}
	
	
	/**
     *
     * @param array $formDatas
     * @return mixed
     */
	public function insertUserinfos($formDatas = array())
	{
		$datas = array(
			'user_id'                   => $formDatas['user_id'],
            'firstname'                 => $formDatas['firstname'],
            'lastname'                  => $formDatas['lastname'],
            'email'                     => $formDatas['email'],
            'address'                   => $formDatas['address'],
            'city'                      => $formDatas['city'],
            'state'                     => $formDatas['state'],
            'country'                   => $formDatas['country'],
            'zipcode'                   => $formDatas['zipcode'],
            'phone_no'                  => $formDatas['phone_no'],
            'comment'                   => $formDatas['comment'],
            'date_modified'             => new Zend_Db_Expr('NOW()'),
            'status'                    => $formDatas['status'],
		);
		return $this->insert($datas);
	}
    
    
    /**
     *
     * @param array $formDatas
     * @return int
     */
	public function updateUserinfos($formDatas = array())
	{
		$datas = array(
            'firstname'                 => $formDatas['firstname'],
            'lastname'                  => $formDatas['lastname'],
            'email'                     => $formDatas['email'],
            'address'                   => $formDatas['address'],
            'city'                      => $formDatas['city'],
            'state'                     => $formDatas['state'],
            'country'                   => $formDatas['country'],
            'zipcode'                   => $formDatas['zipcode'],
            'phone_no'                  => $formDatas['phone_no'],
            'comment'                   => $formDatas['comment'],
            'date_modified'             => new Zend_Db_Expr('NOW()'),
            'status'                    => $formDatas['status'],
		);
		return $this->update($datas, 'user_info_id = ' . (int)$formDatas['user_info_id']);
	}
    
}