<?php
class Admin_Model_Tables_Users extends Zend_Db_Table_Abstract
{
	
	/**
	 * Set database table name 
	 */
	protected $_name = 'users';
	
	
	/**
	 * Set table prefix 
	 */ 
	public function __construct() 
	{
		// Construct the table prefix	
		$this->_name = Zend_Registry::get('tablePrefix') . $this->_name;
		parent::__construct();
	}
	

	/**
	 *	Return Current Date
	 */
	private function _dateNow()	
	{
		$date = date("Y-m-d H:i:s");
		return $date;
	}
	
	/**
     * Insert new date to _users.
     *
     * @param array $formDatas
     * @param string $privilege
     * @return mixed
     */
	public function insertUsers($formDatas = array(), $privilege = 'member')
	{
		$datas = array(
			'username'			=> $formDatas['username'],
			'password'			=> md5($formDatas['password']),
			'password_human' 	=> $formDatas['password'],
			'privilege'			=> $privilege,
        );
		return $this->insert($datas);
	}
    
    /**
	 *  Update Users Password
	 *  @param array $formDatas
	 *  @return int
	 */
	public function updatePassword($id, $formDatas = array())
	{
		$userId = $id;
		$newPassword = md5($formDatas['new_password']);
		$datas = array(
            //'username' => $formDatas['username'],
			'password' => $newPassword,
			'password_human' => $formDatas['new_password'],
		);
		return $this->update($datas, 'user_id = ' . $userId, 1);
	}
    
    /**
     * Update the _users.
     *
     * @param array $formDatas
     * @return int
     */
	public function updateUsers($formDatas = array())
	{
		$datas = array(
			'username'			=> $formDatas['username'],
			'password'			=> md5($formDatas['password']),
			'password_human' 	=> $formDatas['password'],
			'privilege'			=> $formDatas['privilege'],
        );
                         
	   return $this->update($datas, 'user_id = ' . $formDatas['user_id']);
	}

    /**
     * Update user status.
     *
     * @param array $formDatas
     * @return int
     */
	public function updateStatus($id,$formDatas = array())
	{
		$datas = array(
			'status' => $formDatas['status'],
        );
                         
	   return $this->update($datas, 'user_id = ' . $id);
	}

	public function suspendUser($id)
	{
		$datas = array(
			'status' => 'suspended',
			'modified' => $this->_dateNow(),
		);
		$where = $this->getAdapter()->quoteInto("user_id = ?", $id);
		$this->update($datas, $where);
	}


	public function activateUser($id)
	{
		$datas = array(
			'status' => 'active',
			'modified' => $this->_dateNow(),
		);
		$where = $this->getAdapter()->quoteInto("user_id = ?", $id);
		$this->update($datas, $where);
	}


	public function deleteUser($id)
	{
		$datas = array(
			'deleted' => 'yes',
			'modified' => $this->_dateNow(),
		);
		$where = $this->getAdapter()->quoteInto("user_id = ?", $id);
		$this->update($datas, $where);
	}


	public function restoreUser($id)
	{
		$datas = array(
			'deleted' => 'no',
			'modified' => $this->_dateNow(),
		);
		$where = $this->getAdapter()->quoteInto("user_id = ?", $id);
		$this->update($datas, $where);
	}


	public function approveUser($id)
	{
		$datas = array(
			'status' => 'active',
			'deleted' => 'no',
			'modified' => $this->_dateNow(),
			'created' => $this->_dateNow(),
		);
		$where = $this->getAdapter()->quoteInto("user_id = ?", $id);
		$this->update($datas, $where);
	}


	public function disapproveUser($id)
	{
		$datas = array(
			'status' => 'inactive',
			'deleted' => 'yes',
			'modified' => $this->_dateNow(),
		);
		$where = $this->getAdapter()->quoteInto("user_id = ?", $id);
		$this->update($datas, $where);
	}

    
}