<?php
class qa_html_theme extends qa_html_theme_base { 

	function body_content()
	{
		$this->body_prefix();
		$this->notices();
		$this->newFunctions();
		$this->topbar();
		$this->output('<DIV CLASS="qa-body-wrapper">', '');		
		$this->widgets('full', 'top');
		$this->header();
		$this->widgets('full', 'high');
		$this->output('<div class="clear"></div>');
		$this->sidepanel();
		$this->main();
		$this->widgets('full', 'low');
		
		$this->widgets('full', 'bottom');
		$this->output("<div class='clear'></div>");
		$this->output('</DIV> <!-- END body-wrapper -->');
		$this->footer();
		$this->body_suffix();
	}

	function newFunctions()
	{
		$functions = include_once('blocks/functions.php');
	}

	function topbar()
	{
		$topbar = include_once('blocks/top-header-navigation.php');
	}

	function header()
	{
		$this->output('<DIV CLASS="qa-header">');
		
		$this->nav_user_search();
		$this->nav_main_sub();
		$this->header_clear();
		
		$this->output('</DIV> <!-- END qa-header -->', '');
	}

	function nav_user_search()
	{
		// $this->nav('user');
		$this->search();
	}

	function search()
	{
		$search=$this->content['search'];
		$this->output(
			'<DIV CLASS="qa-search">',
			"<span>Search Q&A Forum</span>",
			'<FORM '.$search['form_tags'].'>',
			@$search['form_extra']
		);
		
		$this->search_field($search);
		$this->search_button($search);
		
		$this->output(
			'</FORM>',
			'</DIV>'
		);
	}


	function logo()
	{
		$this->output(
			'<DIV CLASS="logo_con">',
			"<a href='http://localhost/staff-checking/qa/index.php'>",
			'<img src="http://localhost/staff-checking/public/layout/images/logo.png" />',
			'</a>',
			// $this->content['logo'],
			'</DIV>'
		);
	}

	function footer()
	{
		$footer = include_once('blocks/footer.php');
	}

	function sidepanel()
	{
		$dashboard = include_once('blocks/dashboard-controller.php');
	}

	function companyInformation()
	{
		//this show in Company/User Page only
		$param = qa_request();
		$param = explode("/", $param);
		$page = $param[0];

		if($page == 'user')
		{
			$companyName = $param[1];
			$companyInfo = include_once('blocks/company-information.php');
		}

		return false;
	}


	function form($form)
	{
		echo $this->companyInformation();
		if (!empty($form)) {
			$this->section(@$form['title']);
			
			if (isset($form['tags']))
				$this->output('<FORM '.$form['tags'].'>');
			
			$this->form_body($form);

			if (isset($form['tags']))
				$this->output('</FORM>');
		}
	}
 
}